Imports System.Drawing.Printing
Imports System.Xml
#If QRCode Then
Imports IDAutomation.Windows.Forms.QRCodeBarcode
#ElseIf DataBar Then
Imports IDAutomation.Windows.Forms.Databar_Barcode
#ElseIf Linear Then
Imports IDAutomation.Windows.Forms.LinearBarCode
#ElseIf Aztec Then
Imports IDAutomation.Windows.Forms.AztecBarcode
#ElseIf PDF417 Then
Imports IDAutomation.Windows.Forms.PDF417Barcode
#ElseIf MAXI Then
Imports IDAutomation.Windows.Forms.Maxicode
#ElseIf DataMatrix Then
imports IDAutomation.Windows.Forms.DataMatrixBarcode
#End If

Public Class CommonImpementation
    Inherits Form1
    Protected MyBitmap As Bitmap
    Protected TempFileNumber As Integer = 1
    Protected FileTextSize As Integer = 24
    Protected LastSaveExtension As Integer
    Protected TempPath As String = System.IO.Path.GetTempPath()
    
    '*** V2006 Addition in next 2 lines
    Protected LastSaveDirectory As String = ""
    Protected CommandLineArgs As String
    Protected prndoc As PrintDocument = New PrintDocument

    '2010 Additions
    Protected CMDAPP As Integer = 0
    Protected NameFile As String
    Protected SaveFile As String
    Protected FileName As String
    Protected saveFileDialog1 As New SaveFileDialog

#Region "Compiler constant dependedent variables"
#If Aztec Then
    Private Const CompleteSubKey As String = "Software\IDAutomation.com\AztecImageGenerator"
    Private Const PartialSubKey As String = "IDAutomation.com\AztecImageGenerator"
#End If
#If DataMatrix Then
    Private Const CompleteSubKey As String = "Software\IDAutomation.com\DataMatrixImageGenerator"
    Private Const PartialSubKey As String = "IDAutomation.com\DataMatrixImageGenerator"
#End If
#If DataBar Then
    Private Const CompleteSubKey As String = "Software\IDAutomation.com\DataBarImageGenerator"
    Private Const PartialSubKey As String = "IDAutomation.com\DataBarImageGenerator"
#End If
#If Linear Then
    Private Const CompleteSubKey As String = "Software\IDAutomation.com\LinearImageGenerator"
    Private Const PartialSubKey As String = "IDAutomation.com\LinearImageGenerator"
#End If
#If MAXI Then
    Private Const CompleteSubKey As String = "Software\IDAutomation.com\MaxicodeImageGenerator"
    Private Const PartialSubKey As String = "IDAutomation.com\MaxicodeImageGenerator"
#End If
#If QRCode Then
    Private Const CompleteSubKey As String = "Software\IDAutomation.com\QRCodeImageGenerator"
    Private Const PartialSubKey As String = "IDAutomation.com\QRCodeImageGenerator"
#End If
#If PDF417 Then
    Private Const CompleteSubKey As String = "Software\IDAutomation.com\PDF417ImageGenerator"
    Private Const PartialSubKey As String = "IDAutomation.com\PDF417ImageGenerator"
#End If
#End Region

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        CommonLoad()
    End Sub

    Private Sub Form1_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        Try
            SetRegistryValues()
        Catch
        End Try
    End Sub

#Region "Click Events"
    Private Sub mnuAbout_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuAbout.Click
        Dim abt As New frmAbout
        abt.ShowDialog()
    End Sub

    Private Sub btnGenerateImagefile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGenerateImagefile.Click, mnuSaveImage.Click
        saveFileDialog1 = New SaveFileDialog
        '1/5/2009 TB, fix bug #246, try catch taken from linear image generator source
        Try
            saveFileDialog1.FilterIndex = LastSaveExtension
            '1/6/2009 TB, fix bug #260, filterData implemented
            'saveFileDialog1.FileName = filterData(txtDataToEncode.Text) & "-" & Microsoft.VisualBasic.Format(Convert.ToDouble(PDF417Barcode2.ResolutionCustomDPI), "###") & "DPI"
            '2/2/2010 TB, fix bug #384, since windows has a cap on the characters for file names, we will truncate the file name to 60 charcaters
            'saveFileDialog1.FileName = Mid(CommonImageGeneratorMethods.filterData(txtDataToEncode.Text) & "-" & Microsoft.VisualBasic.Format(Convert.ToDouble(PdF417Barcode2.ResolutionCustomDPI), "###") & "DPI", 1, 60)
            saveFileDialog1.FileName = Mid(filterData(txtDataToEncode.Text) & "-" & Microsoft.VisualBasic.Format(Convert.ToDouble(Barcode.ResolutionCustomDPI), "###") & "DPI", 1, 60)
            saveFileDialog1.Filter = "JPEG Image|*.jpeg| TIFF Image|*.tiff| Bitmap Image|*.bmp| PNG Image|*.png| WMF Image|*.wmf| EMF Image|*.emf| EXIF Image|*.exif| GIF Image|*.gif| 1 Bit per pixel BMP|*.bmp"
            saveFileDialog1.Title = "Save an Image File"
            If System.IO.Directory.Exists(LastSaveDirectory) = True Then 'just in case this is the first time it's been accessed or the directory has been deleted
                saveFileDialog1.InitialDirectory = LastSaveDirectory
            End If
            '1/7/2009 TB, fix bug #266
            'saveFileDialog1.ShowDialog()
        Catch
            Windows.Forms.MessageBox.Show("An error occured while trying to save.  Please ensure the filename is properly formatted for the operating system.")
            saveFileDialog1.FileName = "-" & Microsoft.VisualBasic.Format(Convert.ToDouble(Barcode.ResolutionCustomDPI), "###") & "DPI"
            saveFileDialog1.Filter = " JPEG Image|*.jpeg| TIFF Image|*.tiff| Bitmap Image|*.bmp| PNG Image|*.png| WMF Image|*.wmf| EMF Image|*.emf| EXIF Image|*.exif| GIF Image|*.gif| 1 Bit per pixel BMP|*.bmp"
            saveFileDialog1.Title = "Save an Image File"
            If System.IO.Directory.Exists(LastSaveDirectory) = True Then 'just in case this is the first time it's been accessed or the directory has been deleted
                saveFileDialog1.InitialDirectory = LastSaveDirectory
            End If
            '1/7/2009 TB, fix bug #266
            'saveFileDialog1.ShowDialog()
        End Try
        Try
            '1/7/2009 TB, fix bug #266
            If saveFileDialog1.ShowDialog = DialogResult.OK Then
                If saveFileDialog1.FileName <> "" Then
#If Not MAXI And Not DataBar Then
                    Barcode.resolution = Resolutions.Custom
#Else
                    Barcode.resolution = Barcode.resolution.Custom
#End If

                    Barcode.ResolutionCustomDPI = txtImageDPI.Text
                    TempFileNumber = TempFileNumber + 1
                    '*** V2006 Addition in next line
                    LastSaveDirectory = System.IO.Path.GetDirectoryName(saveFileDialog1.FileName)
                    Select Case saveFileDialog1.FilterIndex
                        Case 1
                            Barcode.SaveImageAs(saveFileDialog1.FileName, System.Drawing.Imaging.ImageFormat.Jpeg)
                        Case 2
                            Barcode.SaveImageAs(saveFileDialog1.FileName, System.Drawing.Imaging.ImageFormat.Tiff)
                        Case 3
                            Barcode.SaveImageAs(saveFileDialog1.FileName, System.Drawing.Imaging.ImageFormat.Bmp)
                        Case 4
                            Barcode.SaveImageAs(saveFileDialog1.FileName, System.Drawing.Imaging.ImageFormat.Png)
                        Case 5
                            Barcode.SaveImageAs(saveFileDialog1.FileName, System.Drawing.Imaging.ImageFormat.Wmf)
                        Case 6
                            Barcode.SaveImageAs(saveFileDialog1.FileName, System.Drawing.Imaging.ImageFormat.Emf)
                        Case 7
                            Barcode.SaveImageAs(saveFileDialog1.FileName, System.Drawing.Imaging.ImageFormat.Exif)
                            '*** V2006 Addition in next 2 lines too add in GIF functionality 
                        Case 8
                            Barcode.SaveImageAs(saveFileDialog1.FileName, System.Drawing.Imaging.ImageFormat.Gif)
                        Case 9
                            Barcode.OneBitPerPixelImage = True
                            Barcode.SaveImageAs(saveFileDialog1.FileName, System.Drawing.Imaging.ImageFormat.Bmp)
                            Barcode.OneBitPerPixelImage = False
                    End Select
                End If
            End If
        Catch
            MsgBox("An error occured while trying to save the file. " & vbCr & "Error: Barcode Data")
        End Try
        LastSaveExtension = saveFileDialog1.FilterIndex
    End Sub

    Private Sub btnCopy2Clip_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCopy2Clip.Click, mnuCopy.Click
        'Copy file to clipboard using the Windows API.  The Windows clipboard does not accept .NET's version
        'of copying files to the clipboard.  
        If optIndMF.Checked = True Then
            'make a copy of the emf so that the actual metafile doesn't get invalidated by the Clipboard method
            Dim IndMF As System.Drawing.Imaging.Metafile = Barcode.IndependentEMF.Clone()
            ClipboardHelperFunctions.PutEnhMetafileOnClipboard(Me.Handle, IndMF)
            PicBox.Invalidate()
            PicBox.Image = getImage()
        ElseIf optBitmap.Checked = True Then
            Dim datobj As New System.Windows.Forms.DataObject
            MyBitmap = Barcode.BMPPicture
            datobj.SetData(System.Windows.Forms.DataFormats.Bitmap, Barcode.BMPPicture)
            System.Windows.Forms.Clipboard.SetDataObject(datobj)
            MyBitmap = Nothing
            datobj = Nothing
        End If
    End Sub

    Private Sub mnuSetToMetric_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuSetToMetric.Click
        If mnuSetToMetric.Checked = False Then
            mnuSetToMetric.Checked = True
            mnuSetToInches.Checked = False

#If Not MAXI Then
            ConvertScreenToCM()

            If Val(txtXCM.Text) > 0 Then
                Dim milValue As Double
                milValue = Val(txtXCM.Text) / 1000
                txtXCM.Text = ConvertInchestoCM(Microsoft.VisualBasic.Format(milValue, "#.###").ToString())
            End If
            If Val(txtTopMargin.Text) > 0 Then
                txtTopMargin.Text = ConvertInchestoCM(txtTopMargin.Text)
            End If
            If Val(txtLeftMargin.Text) > 0 Then
                txtLeftMargin.Text = ConvertInchestoCM(txtLeftMargin.Text)
            End If
#End If
#If Linear Or DataBar Then
            If Val(txtBarHeight.Text) > 0 Then
                txtBarHeight.Text = Math.Round(Convert.ToDouble(ConvertInchestoCM(txtBarHeight.Text)), 2).ToString()
            End If
            If Val(txtTextMargin.Text) > 0 Then
                txtTextMargin.Text = ConvertInchestoCM(txtTextMargin.Text)
            End If
#End If
#If Linear Then
            ''12/18/2008
            If Val(txtShortBar.Text) > 0 Then
                txtShortBar.Text = ConvertInchestoCM(txtShortBar.Text)
            End If
#End If
            If Val(txtUpperSpace.Text) > 0 Then
                txtUpperSpace.Text = ConvertInchestoCM(txtUpperSpace.Text)
            End If
            If Val(txtBottomSpace.Text) > 0 Then
                txtBottomSpace.Text = ConvertInchestoCM(txtBottomSpace.Text)
            End If

        End If
    End Sub

    Private Sub mnuSetToInches_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuSetToInches.Click
        If mnuSetToInches.Checked = False Then
            mnuSetToMetric.Checked = False
            mnuSetToInches.Checked = True

#If Not MAXI Then
            ConvertScreenToInches()

            If Val(txtXCM.Text) > 0 Then
                Dim milValue As String = ConvertCMtoInches(txtXCM.Text)
                Dim xdim As Double = Val(milValue * 1000)
                xdim = Math.Round(xdim, 2)
                txtXCM.Text = Microsoft.VisualBasic.Format(xdim, "#.###").ToString()
            End If
            If Val(txtTopMargin.Text) > 0 Then
                txtTopMargin.Text = Math.Round(Convert.ToDouble(ConvertCMtoInches(txtTopMargin.Text)), 3).ToString()
            End If
            If Val(txtLeftMargin.Text) > 0 Then
                txtLeftMargin.Text = Math.Round(Convert.ToDouble(ConvertCMtoInches(txtLeftMargin.Text)), 3).ToString()
            End If
#End If
#If Linear Or DataBar Then
            If Val(txtBarHeight.Text) > 0 Then
                txtBarHeight.Text = Math.Round(Convert.ToDouble(ConvertCMtoInches(txtBarHeight.Text)), 3).ToString()
            End If
            If Val(txtTextMargin.Text) > 0 Then
                txtTextMargin.Text = Math.Round(Convert.ToDouble(ConvertCMtoInches(txtTextMargin.Text)), 3).ToString()
            End If
#End If
#If Linear Then
            ''12/18/2008
            If Val(txtShortBar.Text) > 0 Then
                txtShortBar.Text = Math.Round(Convert.ToDouble(ConvertCMtoInches(txtShortBar.Text)), 3).ToString()
            End If
#End If
            If Val(txtUpperSpace.Text) > 0 Then
                txtUpperSpace.Text = Math.Round(Convert.ToDouble(ConvertCMtoInches(txtUpperSpace.Text)), 3).ToString()
            End If
            If Val(txtBottomSpace.Text) > 0 Then
                txtBottomSpace.Text = Math.Round(Convert.ToDouble(ConvertCMtoInches(txtBottomSpace.Text)), 3).ToString()
            End If
        End If
    End Sub

    Private Sub btnSetBackgroundColor_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetBackgroundColor.Click
        ColorDialog1.Color = Barcode.BackColor
        ColorDialog1.ShowDialog()
        Barcode.BackColor = ColorDialog1.Color
        lblBackgroundColor.ForeColor = Barcode.BackColor
        lblBackgroundColor.BackColor = Barcode.BackColor
        PicBox.Image = getImage()
    End Sub

    Private Sub cmdCaptionFont_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdCaptionFont.Click
        FontDialog1.Font = Barcode.CaptionFontAbove
        FontDialog1.ShowDialog()
        Barcode.CaptionFontAbove = FontDialog1.Font
        ToolTip1.SetToolTip(cmdCaptionFont, "Sets the font of the top caption. Currently font is " & Barcode.CaptionFontAbove.Name & ", " & Barcode.CaptionFontAbove.Size)
        PicBox.Image = getImage()
    End Sub

    Private Sub cmdLowerColor_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdLowerColor.Click
        ColorDialog1.Color = Barcode.CaptionBottomColor
        ColorDialog1.ShowDialog()
        Barcode.CaptionBottomColor = ColorDialog1.Color
        lblBottomCaptionColor.ForeColor = Barcode.CaptionBottomColor
        lblBottomCaptionColor.BackColor = Barcode.CaptionBottomColor
        PicBox.Image = getImage()
    End Sub

    Private Sub cmdSetUpperColor_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdSetUpperColor.Click
        ColorDialog1.Color = Barcode.CaptionTopColor
        ColorDialog1.ShowDialog()
        Barcode.CaptionTopColor = ColorDialog1.Color

        lblUpperCaptionColor.ForeColor = Barcode.CaptionTopColor
        lblUpperCaptionColor.BackColor = Barcode.CaptionTopColor
        PicBox.Image = getImage()
    End Sub

    Private Sub btnSetBarColor_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetBarColor.Click
        ColorDialog1.Color = Barcode.ForeColor
        ColorDialog1.ShowDialog()
        Barcode.ForeColor = ColorDialog1.Color
        lblBarColor.ForeColor = Barcode.ForeColor
        lblBarColor.BackColor = Barcode.ForeColor
        PicBox.Image = getImage()
    End Sub

    Private Sub cmdLowerCaptionFont_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdSetBottomCaptionFont.Click
        FontDialog1.Font = Barcode.CaptionFontBelow
        FontDialog1.ShowDialog()
        Barcode.CaptionFontBelow = FontDialog1.Font
        ToolTip1.SetToolTip(cmdSetBottomCaptionFont, "Sets the font of the top caption. Currently font is " & Barcode.CaptionFontBelow.Name & ", " & Barcode.CaptionFontBelow.Size)
        PicBox.Image = getImage()
    End Sub

    Private Sub btnHelp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnHelp.Click, mnuHelpFile.Click
        Try
            HelpFile.Open()
        Catch
            MsgBox("To access the help file, please choose the icon in the appropriate program group under Start - Programs - IDAutomation...", , "Help File Access")
        End Try
    End Sub

    Private Sub mnuExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuExit.Click
        Try
            SetRegistryValues()
        Catch
            ''Catch ex As Exception
        End Try
        Application.Exit()
    End Sub

    Private Sub DemoLinkLabel_LinkClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles DemoLinkLabel.LinkClicked
        ProcessURL("http://www.idautomation.com/generator/#ORDER", "Please visit", "to place your order", "How to order")
    End Sub

    Dim PrinterToUse As String
    Private Sub btnPrintImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPrintImage.Click, mnuPrintImage.Click
        '1/7/2009 TB, fix bug #270
        Try
            'Select a printer
            Dim frmPrinter As New frmPrintersDialog(PrinterToUse)
            frmPrinter.ShowDialog(Me)
            If frmPrinter.DialogResult = DialogResult.OK And frmPrinter.cboPrinter.Text <> "" Then
                PrinterToUse = frmPrinter.cboPrinter.Text
                If PrinterToUse <> "" Then 'else it will use the default printer
                    prndoc.PrinterSettings.PrinterName = PrinterToUse
                End If
                prndoc.DocumentName = "IDAutomation.com Image Generator Printout"
                AddHandler prndoc.PrintPage, New System.Drawing.Printing.PrintPageEventHandler(AddressOf PrintDocumentOnPrintPage)
                prndoc.Print()
            End If
            frmPrinter = Nothing
        Catch
            MsgBox("An error occurred while trying to print; Check to make sure the print driver is installed and working properly.", , "ERROR:")
        End Try
        'Try
        '    'Select a printer
        '    'Normally you should only call RefreshPrinterDPI for each print job.
        '    Dim prndoc As PrintDocument = New PrintDocument

        '    Dim frmPrinter As New frmPrintersDialog(PrinterToUse)
        '    frmPrinter.ShowDialog(Me)
        '    PrinterToUse = frmPrinter.cboPrinter.Text
        '    If PrinterToUse <> "" And frmPrinter.DialogResult = DialogResult.OK Then
        '        AztecBarcode3.ResolutionPrinterToUse = PrinterToUse
        '        AztecBarcode3.Resolution = AztecBarcode3.Resolutions.Printer
        '        prndoc.PrinterSettings.PrinterName = PrinterToUse
        '        AztecBarcode3.RefreshPrinterDPI()
        '    Else
        '        Exit Sub
        '    End If
        '    frmPrinter = Nothing

        '    prndoc.DocumentName = "IDAutomation.com Image Generator Printout"
        '    AddHandler prndoc.PrintPage, New System.Drawing.Printing.PrintPageEventHandler(AddressOf PrintDocumentOnPrintPage)
        '    prndoc.Print()
        'Catch
        '    MsgBox("An error occurred while trying to print; Check to make sure a printer is installed and working properly.", , "ERROR:")
        'End Try
    End Sub

    Private Sub PrintDocumentOnPrintPage(ByVal sender As Object, ByVal ppea As PrintPageEventArgs)
        '1/7/2009 TB, fix bug #270
        Dim grfx As System.Drawing.Graphics = ppea.Graphics
        grfx.PageUnit = GraphicsUnit.Millimeter
        grfx.PageScale = 1.0F
        grfx.DrawString(Me.Text, Me.Font, Brushes.Black, 0, 0)
        'The new and more efficient method of printing is to use PaintOnGraphics:
        'http://idautomation.com/formscontrols/FormsControlManual.html#Printing_Visual_Studio_Dotnet
        Barcode.PaintOnGraphics(grfx, 20, 200)
        'The old method of printing for previous versions is commented out below this line:
        'Dim grfx As System.Drawing.Graphics = ppea.Graphics
        'Dim myImage As System.Drawing.Imaging.Metafile
        'grfx.PageUnit = GraphicsUnit.Millimeter
        'grfx.PageScale = 1.0F
        'grfx.DrawString(Me.Text + " at " + txtXCM.Text + " CM", Me.Font, Brushes.Black, 0, 0)
        'myImage = AztecBarcode3.Picture
        'grfx.DrawImage(myImage, 0, 20)
    End Sub

    Private Sub mnuSaveXMLFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuSaveXMLFile.Click
        SaveXMLFile(NameFile)
    End Sub

    Private Sub mnuLoadXMLValues_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuLoadXMLValues.Click
        LoadXMLFile(NameFile)
    End Sub

    Private Sub mnuCreateMultipleBarcodes_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuCreateMultipleBarcodes.Click
        LoadExecuteDataToEncode(NameFile)
    End Sub
#If Linear Or DataBar Then
    Private Sub btnSetHRText_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetHRText.Click
        ColorDialog1.Color = Barcode.TextFontColor
        ColorDialog1.ShowDialog()
        Barcode.TextFontColor = ColorDialog1.Color

        lblHRTextColor.ForeColor = ColorDialog1.Color
        lblHRTextColor.BackColor = ColorDialog1.Color
        PicBox.Image = getImage()
    End Sub

    Private Sub btnSetHRTextFont_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetHRTextFont.Click
        FontDialog1.Font = Barcode.Font
        FontDialog1.ShowDialog()
        Barcode.Font = FontDialog1.Font
        lblHRTextFont.Text = Barcode.Font.Name & ", " & Barcode.Font.Size
        PicBox.Image = getImage()
    End Sub
#End If
#End Region

#Region "Changed Events"
    Private Sub txtBottomSpace_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtBottomSpace.TextChanged
        If OnStartUp = False Then
            If Val(txtBottomSpace.Text) > 0 And Val(txtBottomSpace.Text) < 7 Then
                If mnuSetToMetric.Checked = True Then
                    Barcode.CaptionBottomSpace = Val(txtBottomSpace.Text)
                Else
                    Barcode.CaptionBottomSpace = ConvertInchestoCM(txtBottomSpace.Text)
                End If
            ElseIf Val(txtBottomSpace.Text) = 0 Then
                Barcode.CaptionBottomSpace = "0"
            End If
            PicBox.Image = getImage()
        End If
    End Sub

    Private Sub txtUpperSpace_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtUpperSpace.TextChanged
        If OnStartUp = False Then
            If Val(txtUpperSpace.Text) > 0 And Val(txtUpperSpace.Text) < 7 Then
                If mnuSetToMetric.Checked = True Then
                    Barcode.CaptionTopSpace = Val(txtUpperSpace.Text)
                Else
                    Barcode.CaptionTopSpace = ConvertInchestoCM(txtUpperSpace.Text)
                End If
            ElseIf Val(txtUpperSpace.Text) = 0 Then
                Barcode.CaptionTopSpace = "0"
            End If
            PicBox.Image = getImage()
        End If
    End Sub

    Private Sub cboBottomAlignment_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboBottomAlignment.SelectedIndexChanged
        If OnStartUp = False Then
            If cboBottomAlignment.SelectedItem.ToString = "Center" Then
                Barcode.CaptionBottomAlignment = StringAlignment.Center
            ElseIf cboBottomAlignment.SelectedItem.ToString = "Left" Then
                Barcode.CaptionBottomAlignment = StringAlignment.Near
            ElseIf cboBottomAlignment.SelectedItem.ToString = "Right" Then
                Barcode.CaptionBottomAlignment = StringAlignment.Far
            End If
            PicBox.Image = getImage()
        End If
    End Sub

    Private Sub cboUpperAlignment_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboUpperAlignment.SelectedIndexChanged
        If OnStartUp = False Then
            If cboUpperAlignment.SelectedItem.ToString = "Center" Then
                Barcode.CaptionTopAlignment = StringAlignment.Center
            ElseIf cboUpperAlignment.SelectedItem.ToString = "Left" Then
                Barcode.CaptionTopAlignment = StringAlignment.Near
            ElseIf cboUpperAlignment.SelectedItem.ToString = "Right" Then
                Barcode.CaptionTopAlignment = StringAlignment.Far
            End If
            PicBox.Image = getImage()
        End If
    End Sub
#If Not QRCode Then
    Private Sub txtDatatoEncode_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtDataToEncode.TextChanged
        If OnStartUp = False Then
            Barcode.DataToEncode = txtDataToEncode.Text
            PicBox.Image = getImage()
        End If
    End Sub
#End If
    Private Sub txtImageDPI_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtImageDPI.TextChanged
        If OnStartUp = False Then
            Barcode.Resolution = Barcode.Resolution.Custom
            Barcode.ResolutionCustomDPI = Val(txtImageDPI.Text)
            PicBox.Image = getImage()
        End If
    End Sub

    Private Sub ApplyTilde_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ApplyTilde.CheckedChanged
        If OnStartUp = False Then
            Barcode.ApplyTilde = ApplyTilde.Checked
            PicBox.Image = getImage()
        End If
    End Sub

    Private Sub txtUpperCaption_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtUpperCaption.TextChanged
        If OnStartUp = False Then
            Barcode.CaptionAbove = txtUpperCaption.Text
            PicBox.Image = getImage()
        End If
    End Sub

    Private Sub txtBottomCaption_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtBottomCaption.TextChanged
        If OnStartUp = False Then
            Barcode.CaptionBelow = txtBottomCaption.Text
            PicBox.Image = getImage()
        End If
    End Sub

    Private Sub cboRotation_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboRotation.SelectedIndexChanged
        If OnStartUp = False Then
            If cboRotation.SelectedItem.ToString() = "0 Degrees" Then
                Barcode.RotationAngle = Barcode.RotationAngle.Zero_Degrees
            End If
            If cboRotation.SelectedItem.ToString() = "90 Degrees" Then
                Barcode.RotationAngle = Barcode.RotationAngle.Ninety_Degrees
            End If
            If cboRotation.SelectedItem.ToString() = "180 Degrees" Then
                Barcode.RotationAngle = Barcode.RotationAngle.One_Hundred_Eighty_Degrees
            End If
            If cboRotation.SelectedItem.ToString() = "270 Degrees" Then
                Barcode.RotationAngle = Barcode.RotationAngle.Two_Hundred_Seventy_Degrees
            End If
            PicBox.Image = getImage()
        End If
    End Sub

#If Not MAXI Then
    Private Sub txtLeftMargin_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtLeftMargin.TextChanged
        If OnStartUp = False Then
            If Val(txtLeftMargin.Text) > 0 And Val(txtLeftMargin.Text) < 50 Then
                If mnuSetToMetric.Checked = True Then
                    Barcode.LeftMarginCM = Val(txtLeftMargin.Text)
                Else
                    Barcode.LeftMarginCM = ConvertInchestoCM(txtLeftMargin.Text)
                End If
            ElseIf Val(txtLeftMargin.Text) = 0 Then
                Barcode.LeftMarginCM = "0"
            End If
            PicBox.Image = getImage()
        End If
    End Sub

    Private Sub txtTopMargin_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtTopMargin.TextChanged
        If OnStartUp = False Then
            If Val(txtTopMargin.Text) > 0 And Val(txtTopMargin.Text) < 50 Then
                If mnuSetToMetric.Checked = True Then
                    Barcode.TopMarginCM = Val(txtTopMargin.Text)
                Else
                    Barcode.TopMarginCM = ConvertInchestoCM(txtTopMargin.Text)
                End If
            ElseIf Val(txtTopMargin.Text) = 0 Then
                Barcode.TopMarginCM = "0"
            End If
            PicBox.Image = getImage()
        End If
    End Sub

    Private Sub txtXCM_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtXCM.TextChanged
        If OnStartUp = False Then
            If mnuSetToMetric.Checked = True Then
                If Val(txtXCM.Text) > 0 And Val(txtXCM.Text) < 7 Then
                    Barcode.XDimensionCM = Val(txtXCM.Text)
                End If
            Else
                Dim milVal As Double = Val(txtXCM.Text)
                milVal = Math.Round(milVal / 1000, 3)
                Barcode.XDimensionCM = Val(ConvertInchestoCM(Microsoft.VisualBasic.Format(milVal, "#.###").ToString()))
            End If
            PicBox.Image = getImage()
        End If
    End Sub
#End If


#Region "Linear or Databar"
#If DataBar Or Linear Then
    Private Sub cboCode128Set_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboCode128Set.SelectedIndexChanged
        If OnStartUp = False Then
            Barcode.Code128Set = cboCode128Set.SelectedIndex
            PicBox.Image = getImage()
        End If
    End Sub

    Private Sub chkShowText_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkShowText.CheckedChanged
        If OnStartUp = False Then
            If chkShowText.Checked = True Then
                Barcode.ShowText = True
            Else
                Barcode.ShowText = False
            End If
            PicBox.Image = getImage()
        End If
    End Sub

    Private Sub txtBarHeight_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtBarHeight.TextChanged
        If OnStartUp = False Then
            If Val(txtBarHeight.Text) > 0 And Val(txtBarHeight.Text) < 50 Then
                If mnuSetToMetric.Checked = True Then
                    Barcode.BarHeightCM = Val(txtBarHeight.Text)
                Else
                    Barcode.BarHeightCM = ConvertInchestoCM(txtBarHeight.Text)
                End If
                PicBox.Image = getImage()
            End If
        End If
    End Sub

    Private Sub chkTextAbove_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkTextAbove.CheckedChanged
        If OnStartUp = False Then
            If chkTextAbove.Checked = True Then
#If DataBar Then
                Barcode.ShowTextLocation = Barcode.HRTextPositions.Top
#Else
                Barcode.ShowTextLocation = HRTextPositions.Top
#End If
            Else
#If DataBar Then
                Barcode.ShowTextLocation = Barcode.HRTextPositions.Bottom
#Else
                Barcode.ShowTextLocation = HRTextPositions.Bottom
#End If
            End If
            PicBox.Image = getImage()
        End If
    End Sub

    Private Sub txtTextMargin_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtTextMargin.TextChanged
        If OnStartUp = False Then
            If Val(txtTextMargin.Text) > 0 And Val(txtTextMargin.Text) < 10 Then
                If mnuSetToMetric.Checked = True Then
                    Barcode.TextMarginCM = Val(txtTextMargin.Text)
                Else
                    Barcode.TextMarginCM = ConvertInchestoCM(txtTextMargin.Text)
                End If
            ElseIf Val(txtTextMargin.Text) = 0 Then
                Barcode.TextMarginCM = "0"
            End If
            PicBox.Image = getImage()
        End If
    End Sub

    Private Sub cboUPCESystem_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboUPCESystem.SelectedIndexChanged
        If OnStartUp = False Then
            If cboUPCESystem.Text.ToUpper() = "AUTO" Then
                Barcode.UPCESystem = "Auto"
            ElseIf cboUPCESystem.Text = "1" Then
                Barcode.UPCESystem = "1"
            Else
                Barcode.UPCESystem = "0"
            End If
            PicBox.Image = getImage()
        End If
    End Sub
#End If
#End Region
#End Region

#Region "Methods"
    Public Shared Sub ProcessURL(ByVal url As String, Optional ByVal description1 As String = "Please open", Optional ByVal description2 As String = "", Optional ByVal Title As String = "")
        Try
            System.Diagnostics.Process.Start(url)
        Catch ex As Exception
            Try
                Shell(url)
            Catch ex2 As Exception
                If Title = "" Then
                    Title = Application.ProductName
                End If
                MsgBox(description1 & " " & url & " " & description2, , Title)
            End Try
        End Try
    End Sub

    '1/6/2009 TB, fix bug #260
    Public Function filterData(ByVal DataToFilter As String) As String
        Dim arDataToFilter() As Char = DataToFilter.ToCharArray
        Dim FilteredString As String = ""
        Dim strLen As Integer = DataToFilter.Length - 1
        Dim x As Integer
        For x = 0 To strLen
            If (arDataToFilter(x) >= Chr(48) And arDataToFilter(x) <= Chr(57)) Or _
            (arDataToFilter(x) >= Chr(65) And arDataToFilter(x) <= Chr(90)) Or _
            (arDataToFilter(x) >= Chr(97) And arDataToFilter(x) <= Chr(122)) Then
                FilteredString = FilteredString + arDataToFilter(x)
            End If
        Next x
        filterData = FilteredString
    End Function

    'Converts CM value to inches
    Protected Function ConvertCMtoInches(ByVal inputCM As String) As String
        Try
            Dim conversion As Double = (Val(inputCM) / 2.54)
            Return Microsoft.VisualBasic.Format(conversion, "#.###").ToString()
        Catch
            Return inputCM
        End Try
    End Function

    'Converts Inches to CM
    Protected Function ConvertInchestoCM(ByVal inputIN As String) As String
        Try
            Dim conversion As Double = (Val(inputIN) * 2.54)
            Return Microsoft.VisualBasic.Format(conversion, "#.###").ToString()
        Catch
            Return inputIN
        End Try
    End Function

    Protected Function getImage()
        getImage = Barcode.IndependentEMF
    End Function

    Private Sub LoadExecuteDataToEncode(ByRef NameFile As String)
        Dim FileNameC As String = ""
        Dim LoadedDirectory As String = "" 'directory to load the DataToEncode files
        Dim OpenFileDialog1 As New OpenFileDialog
        Dim numofbarcode As Integer = 1

        Try
            Dim oFile As System.IO.File

            'FileName from command line
            If CMDAPP = 1 Then
                FileNameC = "" '
                FileNameC = NameFile
                Me.Visible = False
            Else
                'FileName from diaglog box
                'Open File Dialog to load text file containing DataToEncode values.
                With OpenFileDialog1
                    .FileName = FileNameC
                    ''Ensure that it does not load incorrect File extension
                    If (.Filter <> "TXT files (*.txt)|*.txt|" & "All files|*.*") Then
                        FileNameC = ""
                    End If

                    .Filter = "TXT files (*.txt)|*.txt|" & "All files|*.*"
                    If .ShowDialog() = DialogResult.OK Then
                        FileNameC = .FileName
                    End If
                End With
            End If

        Catch
            Windows.Forms.MessageBox.Show("An error occured while trying to load the file.  Please ensure the filename is properly formatted for the operating system.")
        End Try

        If FileNameC <> "" Then
            Try
                'Open File for reading. "Filename" is the name of the file that contains the data.
                Dim oRead As New System.IO.StreamReader(FileNameC)
                '1/7/2011, TB, variables added to implement feature #412
                Dim LineData As String 'current line of data read from the txt file
                Dim setImageType As Boolean = True 'indicates if the line read is setting the image type
                Dim ImageType As String = "GIF" 'type of image that is being created
                Dim FileExt As String = ".gif" 'file extension of the image being crated
                Dim ImgFormat As System.Drawing.Imaging.ImageFormat = System.Drawing.Imaging.ImageFormat.Gif
                Dim ValidImgType As Boolean = True 'if the image type is one of the choices it will be forced to gif
                'We will read all the contents of the file
                Do While oRead.Peek() <> -1

                    'Set the line read to from the file
                    LineData = oRead.ReadLine()
                    '1/7/2011,TB,feature #412, here we test if the line read is setting the image type
                    Dim strToCheck As String = LineData.ToUpper().Trim()
                    Dim ImgTagIdx As Integer = strToCheck.IndexOf("IMAGE:")
                    If ImgTagIdx <> 0 Then

                        Me.Barcode.DataToEncode = LineData
                        'Set the data to display in the text box
                        Me.txtDataToEncode.Text = Me.Barcode.DataToEncode
                        setImageType = False
                    Else
                        setImageType = True
                    End If

                    '1/7/2011,TB,feature #412, we are here if the line read is data, and not setting the image type
                    If setImageType = False Then
                        'We save the image 
                        saveFileDialog1 = New SaveFileDialog

                        'Take first 60 characters 
                        Dim strFileNameLimit As String = Mid(Me.txtDataToEncode.Text, 1, 60)

                        LastSaveExtension = saveFileDialog1.FilterIndex
                        LoadedDirectory = System.IO.Path.GetDirectoryName(FileNameC)
                        saveFileDialog1.InitialDirectory = LoadedDirectory

                        Barcode.SaveImageAs(LoadedDirectory & "\" & numofbarcode & "-" & filterData(strFileNameLimit) & "-" & Microsoft.VisualBasic.Format(Convert.ToDouble(Barcode.ResolutionCustomDPI), "###") & "DPI" & FileExt, ImgFormat)
                        LastSaveExtension = saveFileDialog1.FilterIndex
                        numofbarcode = numofbarcode + 1
                        ' End If

                        strFileNameLimit = ""
                    Else
                        '1/7/2011,TB,feature #412, we are here if the line read is setting the image type
                        ImageType = Trim(LineData.Substring(LineData.IndexOf(":") + 1).ToUpper) 'force the image type to upper case so it will not matter which case the image is in, and also trim any spaces
                        ValidImgType = True
                        Select Case ImageType
                            Case "JPEG"
                                ImgFormat = System.Drawing.Imaging.ImageFormat.Jpeg
                            Case "GIF"
                                ImgFormat = System.Drawing.Imaging.ImageFormat.Gif
                            Case "BMP"
                                ImgFormat = System.Drawing.Imaging.ImageFormat.Bmp
                            Case "PNG"
                                ImgFormat = System.Drawing.Imaging.ImageFormat.Png
                            Case "WMF"
                                ImgFormat = System.Drawing.Imaging.ImageFormat.Wmf
                            Case "EMF"
                                ImgFormat = System.Drawing.Imaging.ImageFormat.Emf
                            Case "TIFF"
                                ImgFormat = System.Drawing.Imaging.ImageFormat.Tiff
                            Case "1BMP"
                                ImgFormat = System.Drawing.Imaging.ImageFormat.Bmp
                                Barcode.OneBitPerPixelImage = True
                                FileExt = ".bmp"
                            Case Else
                                ImgFormat = System.Drawing.Imaging.ImageFormat.Gif
                                Barcode.OneBitPerPixelImage = False
                                FileExt = ".gif"
                                ValidImgType = False
                        End Select
                        If ImageType <> "1BMP" And ValidImgType = True Then 'we only want to do this if the image type is valid and if it is not a 1BMP
                            Barcode.OneBitPerPixelImage = False 'if the prior image type was 1BMP we need to turn OneBitPerPixelImage off
                            FileExt = "." & ImageType.ToLower()
                        End If
                    End If
                Loop
                'Close text file.
                oRead.Close()
            Catch
            End Try
        End If
        numofbarcode = 1
    End Sub

    Private Sub CommonLoad(Optional ByRef SuppressChange As Boolean = True)
        'abt = New frmAbout
        Me.Text = Application.ProductName & " Version " & Application.ProductVersion.Replace(".0", "")
        lblCopyright.Text = "Copyright  2003-" & Application.ProductVersion.Replace(".0", "") & " IDAutomation.com, Inc."
        '1/6/2010 BRJ Fixes issue Jack found with 120dpi
        fixFonts(Me)
        SetToolTips(ToolTip1)

        '*** V2006 Addition in next section to keep app invisible
        Dim CommandLineArgs As String = Microsoft.VisualBasic.Command()
        If CommandLineArgs <> "" Then
            Me.Visible = False
            Me.ShowInTaskbar = False
        End If
        OnStartUp = False
#If Linear Then
        cboSymbology.Items.Add("CODE11")
        cboSymbology.Items.Add("CODE39")
        cboSymbology.Items.Add("CODE39EXT")
        cboSymbology.Items.Add("INTERLEAVED25")
        cboSymbology.Items.Add("CODABAR")
        cboSymbology.Items.Add("MSI")
        cboSymbology.Items.Add("TELEPEN")
        cboSymbology.Items.Add("UPCA")
        cboSymbology.Items.Add("IND25")
        cboSymbology.Items.Add("MAT25")
        cboSymbology.Items.Add("EAN13")
        cboSymbology.Items.Add("EAN8")
        cboSymbology.Items.Add("UPCE")
        cboSymbology.Items.Add("CODE128")
        cboSymbology.Items.Add("CODE93")
        cboSymbology.Items.Add("CODE93EXT")
        cboSymbology.Items.Add("POSTNET")
        cboSymbology.Items.Add("PLANET")
        cboSymbology.Items.Add("INTELLIGENTMAIL")

        cboSymbology.SelectedIndex = cboSymbology.Items.IndexOf("CODE128")


        cboUPCESystem.Items.Add("Auto")
#End If
#If DataBar Then
        cboSymbology.Items.Add("DataBar")
        cboSymbology.Items.Add("DataBar Truncated")
        cboSymbology.Items.Add("DataBar Stacked")
        cboSymbology.Items.Add("DataBar Stacked Omnidirectional")
        cboSymbology.Items.Add("DataBar Limited")
        cboSymbology.Items.Add("DataBar Expanded")
        cboSymbology.Items.Add("CODE 128")
        cboSymbology.Items.Add("EAN 13")
        cboSymbology.Items.Add("EAN 8")
        cboSymbology.Items.Add("UPCa")
        cboSymbology.Items.Add("UPCe")
        cboSymbology.Items.Add("MICRO_PDF417")
        cboSymbology.Items.Add("PDF417")

        cboSymbology.SelectedIndex = cboSymbology.Items.IndexOf("DataBar")

        cboSegments.Items.Add("2")
        cboSegments.Items.Add("4")
        cboSegments.Items.Add("6")
        cboSegments.Items.Add("8")
        cboSegments.Items.Add("10")
        cboSegments.Items.Add("12")
        cboSegments.Items.Add("14")
        cboSegments.Items.Add("16")
        cboSegments.Items.Add("18")
        cboSegments.Items.Add("20")
        cboSegments.Items.Add("22")
#End If
#If DataBar Or Linear Then
        cboUPCESystem.Items.Add("0")
        cboUPCESystem.Items.Add("1")

        cboCode128Set.Items.Add("Auto")
        cboCode128Set.Items.Add("A")
        cboCode128Set.Items.Add("B")
        cboCode128Set.Items.Add("C")
#End If

        cboRotation.Items.Add("0 Degrees")
        cboRotation.Items.Add("90 Degrees")
        cboRotation.Items.Add("180 Degrees")
        cboRotation.Items.Add("270 Degrees")

        Dim sep As String = "+" 'currently set to the space between each argument
        Dim args() As String = CommandLineArgs.Split(sep.ToCharArray, 4)
        Dim command As String = args(0).ToUpper() 'Command operation
        Dim NameFile As String 'File being pulled

        '''Update BRJ 10/9/09 Allows user to Load Data file for data to encode, load and save xml file with values using command
        '''line.
        If CommandLineArgs <> "" Then
            Try
                ''Calls To Create Multiple Barcodes
                Me.Visible = False
                Me.ShowInTaskbar = False
                If command = "CREATEBARCODES" Then
                    CMDAPP = 1
                    Me.Visible = False
                    ''Load and read text file
                    NameFile = args(1) '1/10/2011, TB, fix Bug #414, initialize NameFile
                    LoadExecuteDataToEncode(NameFile)
                    ' End If
                    '''Calls To Load Values
                ElseIf command = "LOADVALUES" Then
                    Me.Visible = False
                    Me.ShowInTaskbar = False
                    CMDAPP = 1
                    NameFile = args(1)
                    LoadXMLFile(NameFile)

                    'Create data to encode by loading file and saving images.
                    If args(2).ToUpper = "CREATEBARCODES" Then
                        CMDAPP = 1
                        NameFile = args(3)
                        Me.Visible = False
                        ''Load and read text file
                        LoadExecuteDataToEncode(NameFile)
                    Else
                        'Creating Data To Encode and Saving 1 Image
                        Barcode.DataToEncode = args(2)
                        Try
                            If (args(3)) = "" Then
                                args(3) = args(2)
                            End If

                            sep = "."
                            Dim FileName() As String = (args(3)).Split(sep.ToCharArray, 2)
                            Dim ImageType = FileName(1).ToUpper

                            Try
                                Select Case ImageType
                                    Case "JPEG"
                                        Barcode.SaveImageAs(args(3), System.Drawing.Imaging.ImageFormat.Jpeg)
                                    Case "GIF"
                                        Barcode.SaveImageAs(args(3), System.Drawing.Imaging.ImageFormat.Gif)
                                    Case "BMP"
                                        Barcode.SaveImageAs(args(3), System.Drawing.Imaging.ImageFormat.Bmp)
                                    Case "PNG"
                                        Barcode.SaveImageAs(args(3), System.Drawing.Imaging.ImageFormat.Png)
                                    Case "WMF"
                                        Barcode.SaveImageAs(args(3), System.Drawing.Imaging.ImageFormat.Wmf)
                                    Case "EMF"
                                        Barcode.SaveImageAs(args(3), System.Drawing.Imaging.ImageFormat.Emf)
                                    Case "TIFF"
                                        Barcode.SaveImageAs(args(3), System.Drawing.Imaging.ImageFormat.Tiff)
                                    Case "1BMP"
                                        Barcode.OneBitPerPixelImage = True
                                        Barcode.SaveImageAs(args(3).Remove(args(3).LastIndexOf("1"), 1), System.Drawing.Imaging.ImageFormat.Bmp)
                                        Barcode.OneBitPerPixelImage = False
                                    Case Else
                                        Barcode.SaveImageAs(args(3), System.Drawing.Imaging.ImageFormat.Jpeg)
                                End Select
                            Catch
                                Barcode.SaveImageAs(args(3) & ".jpeg", System.Drawing.Imaging.ImageFormat.Jpeg)
                            End Try
                        Catch
                            Windows.Forms.MessageBox.Show("A Data To Encode value must be entered.")
                        End Try
                    End If
                ElseIf (command <> "LOADVALUES" Or command <> "CREATEBARCODES") Then
                    sep = " "
                    Dim arg() As String = CommandLineArgs.Split(sep.ToCharArray, 2)
                    'Creating Data To Encode and Saving 1 Image

                    Barcode.DataToEncode = arg(0)
                    sep = "."

                    'TB, 1/3/2011, fix bug #393, made a variable for the arg array index, 
                    'if the length of arg is greater than 1 then the index is forced to 1
                    Dim arrIdx As Integer
                    Dim FileName() As String
                    Dim ImageType As String
                    Dim PathAndFileName As String 'TB, 1/7/2011, fix bug #393, string to hold both path and file name

                    If arg.Length > 1 Then
                        arrIdx = 1
                        '1/10/2011, TB, fix bug #415, check for a dot in the first place of the second command argument
                        If arg(arrIdx).Substring(0, 1) <> "." Then
                            FileName = (arg(arrIdx)).Split(sep.ToCharArray, 2) 'if there is no dot then just split into 2
                        Else
                            FileName = (arg(arrIdx)).Split(sep.ToCharArray) 'if there is a dot then just split into as many as needed
                        End If
                        ImageType = FileName(FileName.Length - 1).ToUpper '1/10/2011, TB, fix bug #415, the last string in array is the file type
                        PathAndFileName = arg(arrIdx)
                    Else
                        arrIdx = 0
                        ImageType = "JPEG"
                        PathAndFileName = Environment.CurrentDirectory() & "\" & arg(arrIdx) & ".jpeg"
                    End If
                    Try
                        Select Case ImageType
                            Case "JPEG"
                                Barcode.SaveImageAs(PathAndFileName, System.Drawing.Imaging.ImageFormat.Jpeg)
                            Case "GIF"
                                Barcode.SaveImageAs(PathAndFileName, System.Drawing.Imaging.ImageFormat.Gif)
                            Case "BMP"
                                Barcode.SaveImageAs(PathAndFileName, System.Drawing.Imaging.ImageFormat.Bmp)
                            Case "PNG"
                                Barcode.SaveImageAs(PathAndFileName, System.Drawing.Imaging.ImageFormat.Png)
                            Case "WMF"
                                Barcode.SaveImageAs(PathAndFileName, System.Drawing.Imaging.ImageFormat.Wmf)
                            Case "EMF"
                                Barcode.SaveImageAs(PathAndFileName, System.Drawing.Imaging.ImageFormat.Emf)
                            Case "TIFF"
                                Barcode.SaveImageAs(PathAndFileName, System.Drawing.Imaging.ImageFormat.Tiff)
                            Case "1BMP"
                                Barcode.OneBitPerPixelImage = True 'TB, 1/7/2011, fix bug #393,
                                Barcode.SaveImageAs(PathAndFileName.Remove(PathAndFileName.LastIndexOf("1"), 1), System.Drawing.Imaging.ImageFormat.Bmp)
                                Barcode.OneBitPerPixelImage = False
                            Case Else
                                Barcode.SaveImageAs(PathAndFileName, System.Drawing.Imaging.ImageFormat.Jpeg)
                        End Select
                    Catch
                        Barcode.SaveImageAs(PathAndFileName & ".jpeg", System.Drawing.Imaging.ImageFormat.Jpeg)
                    End Try
                End If
            Catch ex As Exception
                MsgBox(ex.Message)
            End Try
            Application.Exit()
        End If
        ToolTip1.AutomaticDelay = 1500

        If Barcode.IsDemo = True Then
            DemoText.Visible = True
            DemoLinkLabel.Visible = True
        End If
        GetRegistryValues()
        OnStartUp = False
        '12/2008 modification to only allow bitmap; fixes problems in some situations
        '  such as when pasting images into graphic applications
        'optBitmap.Checked = True
    End Sub

    'Load XML File
    Private Sub LoadXMLFile(ByVal NameFile As String, Optional ByRef SuppressChange As Boolean = False)
        Dim FileNameL As String = ""
        ''Declare a OpenFileDialog object
        Dim OpenFileDialog1 As New OpenFileDialog

        Try
            ''FileName from command line
            If CMDAPP = 1 Then
                'Me.Visible = False
                FileNameL = ""
                FileNameL = NameFile
            Else
                With OpenFileDialog1
                    ''FileName from dialog box
                    .FileName = FileNameL

                    ''Ensure that it does not load incorrect File extension
                    If (.Filter <> "XML files (*.xml)|*.xml|" & "All files|*.*") Then
                        FileNameL = ""
                    End If

                    .Filter = "XML files (*.xml)|*.xml|" & "All files|*.*"
                    If .ShowDialog() = DialogResult.OK Then
                        FileNameL = .FileName
                    End If
                End With
            End If
        Catch
            Windows.Forms.MessageBox.Show("An error occured while trying to load the file.  Please ensure the filename is properly formatted for the operating system.")
        End Try

        Dim myXmlTextReader As XmlTextReader
        Dim xmlExcept As XmlException
        If FileNameL <> "" Then
            Try
                '12/28/2010, TB, Added Feature #411
                Dim Data(17) As String 'String array to hold the data to encode values from the xml file.

                myXmlTextReader = New XmlTextReader(FileNameL)

                '12/28/2010, TB, Added Feature #411, restructure of the LoadXMLFile method. We need a While loop for the reader that test for the name of the current element
                'using just the ReadElementString like in the older versions required that the elements be read in the same order that they were written too, 
                'and if an element did not exisit then an error was thrown. So since new propeties were added to the new version any xml files that were created with prior versions would not load.
                While myXmlTextReader.Read()
                    Select Case myXmlTextReader.Name
                        Case "ApplyTilde"
                            ApplyTilde.Checked = myXmlTextReader.ReadElementString("ApplyTilde")
                        Case "BarColor"
                            Barcode.ForeColor = Barcode.ForeColor.FromArgb(myXmlTextReader.ReadElementString("BarColor"))
                        Case "BackColor"
                            Barcode.BackColor = Barcode.BackColor.FromArgb(myXmlTextReader.ReadElementString("BackColor"))
                        Case "CaptionAbove"
                            txtUpperCaption.Text = myXmlTextReader.ReadElementString("CaptionAbove")
                        Case "CaptionBelow"
                            txtBottomCaption.Text = myXmlTextReader.ReadElementString("CaptionBelow")
                        Case "CaptionBottomAlignment"
                            cboBottomAlignment.SelectedItem = myXmlTextReader.ReadElementString("CaptionBottomAlignment")
                        Case "CaptionBottomColor"
                            Barcode.CaptionBottomColor = Barcode.CaptionBottomColor.FromArgb(myXmlTextReader.ReadElementString("CaptionBottomColor"))
                        Case "CaptionBottomSpace"
                            txtBottomSpace.Text = myXmlTextReader.ReadElementString("CaptionBottomSpace")
                        Case "CaptionTopAlignment"
                            cboUpperAlignment.SelectedItem = myXmlTextReader.ReadElementString("CaptionTopAlignment")
                        Case "CaptionTopColor"
                            Barcode.CaptionTopColor = Barcode.CaptionTopColor.FromArgb(myXmlTextReader.ReadElementString("CaptionTopColor"))
                        Case "CaptionTopSpace"
                            txtUpperSpace.Text = myXmlTextReader.ReadElementString("CaptionTopSpace")
                        Case "DataToEncode"
#If QRCode Then
                            Data(0) = myXmlTextReader.ReadElementString("DataToEncode")
#Else
                            txtDataToEncode.Text = myXmlTextReader.ReadElementString("DataToEncode")
#End If
                        Case "ImageResolution"
                            '7/79/11, TB, Fix bug# 249
                            txtImageDPI.Text = myXmlTextReader.ReadElementString("ImageResolution")
#If Not DataBar Then
                            Barcode.Resolution = Resolutions.Custom
#Else
                            Barcode.Resolution = Barcode.Resolutions.Custom
#End If
                            Barcode.ResolutionCustomDPI = txtImageDPI.Text
                        Case "LastSaveDirectory"
                            LastSaveDirectory = myXmlTextReader.ReadElementString("LastSaveDirectory")
                        Case "LastSaveExtension"
                            LastSaveExtension = myXmlTextReader.ReadElementString("LastSaveExtension")
                        Case "Orientation"
                            cboRotation.SelectedItem = myXmlTextReader.ReadElementString("Orientation")
                        Case "SetUnitInches"
                            mnuSetToInches.Checked = myXmlTextReader.ReadElementString("SetUnitInches")
                        Case "SetUnitMetric"
                            mnuSetToMetric.Checked = myXmlTextReader.ReadElementString("SetUnitMetric")
                        Case "Width"
                            Barcode.Width = myXmlTextReader.ReadElementString("Width")
                        Case "Top"
                            Barcode.Top = myXmlTextReader.ReadElementString("Top")
                        Case "Left"
                            Barcode.Left = myXmlTextReader.ReadElementString("Left")
                        Case "Height"
                            Barcode.Height = myXmlTextReader.ReadElementString("Height")
#If Not MAXI Then
                        Case "LeftMargin"
                            txtLeftMargin.Text = myXmlTextReader.ReadElementString("LeftMargin")
                        Case "TopMargin"
                            txtTopMargin.Text = myXmlTextReader.ReadElementString("TopMargin")
                        Case "X"
                            txtXCM.Text = myXmlTextReader.ReadElementString("X")
#End If
                        Case "Bitmap"
                            If myXmlTextReader.ReadElementString("Bitmap") = True Then
                                optBitmap.Checked = True
                                optIndMF.Checked = False
                            Else
                                optBitmap.Checked = False
                                optIndMF.Checked = True
                            End If
#If QRCode Then
                        Case "EncodingMode"
                            cboEncodingMode.SelectedItem() = myXmlTextReader.ReadElementString("EncodingMode")
                        Case "ErrorCorrectionLevel"
                            cboErrorCorrectionLevel.SelectedItem = myXmlTextReader.ReadElementString("ErrorCorrectionLevel")
                        Case "Version"
                            cboVersions.SelectedItem = myXmlTextReader.ReadElementString("Version")
                        Case "VCARDWorkNumber"
                            Data(1) = myXmlTextReader.ReadElementString("VCARDWorkNumber")
                        Case "VCARDEmail"
                            Data(2) = myXmlTextReader.ReadElementString("VCARDEmail")
                        Case "VCARDWebsite"
                            Data(3) = myXmlTextReader.ReadElementString("VCARDWebsite")
                        Case "VCARDFirstName"
                            Data(4) = myXmlTextReader.ReadElementString("VCARDFirstName")
                        Case "VCARDLastName"
                            Data(5) = myXmlTextReader.ReadElementString("VCARDLastName")
                        Case "VCARDCompany"
                            Data(6) = myXmlTextReader.ReadElementString("VCARDCompany")
                        Case "VCARDPosition"
                            Data(7) = myXmlTextReader.ReadElementString("VCARDPosition")
                        Case "VCARDAddress"
                            Data(8) = myXmlTextReader.ReadElementString("VCARDAddress")
                        Case "VCARDCity"
                            Data(9) = myXmlTextReader.ReadElementString("VCARDCity")
                        Case "VCARDState"
                            Data(10) = myXmlTextReader.ReadElementString("VCARDState")
                        Case "VCARDZip"
                            Data(11) = myXmlTextReader.ReadElementString("VCARDZip")
                        Case "CmWorkNumber"
                            Data(12) = myXmlTextReader.ReadElementString("CmWorkNumber")
                        Case "CmEmail"
                            Data(13) = myXmlTextReader.ReadElementString("CmEmail")
                        Case "CmText"
                            Data(14) = myXmlTextReader.ReadElementString("CmText")
                        Case "CmWebsite"
                            Data(15) = myXmlTextReader.ReadElementString("CmWebsite")
                        Case "DataStatus"
                            Data(16) = myXmlTextReader.ReadElementString("DataStatus")
#End If
#If PDF417 Then
                        Case "Columns"
                            txtPDFColumns.Text = myXmlTextReader.ReadElementString("Columns")
                        Case "EncodingMode"
                            cboEncodingMode.SelectedItem = myXmlTextReader.ReadElementString("EncodingMode")
                        Case "ErrorCorrectionLevel"
                            txtPDFEC.Text = myXmlTextReader.ReadElementString("ErrorCorrectionLevel")
                        Case "MacroPDFEnable"
                            chkMacroPDFEnable.Checked = myXmlTextReader.ReadElementString("MacroPDFEnable")
                        Case "MacroPDFFileID"
                            txtMacroPDFFileID.Text = myXmlTextReader.ReadElementString("MacroPDFFileID")
                        Case "MacroPDFLastSegment"
                            chkMacroPDFLastSegment.Checked = myXmlTextReader.ReadElementString("MacroPDFLastSegment")
                        Case "MacroPDFSegmentIndex"
                            txtMacroPDFSegmentIndex.Text = myXmlTextReader.ReadElementString("MacroPDFSegmentIndex")
                        Case "Truncated"
                            chkTruncate.Checked = myXmlTextReader.ReadElementString("Truncated")
                        Case "XYRatio"
                            txtXYRatio.Text = myXmlTextReader.ReadElementString("XYRatio")
                        Case "Rows"
                            txtPDFRows.Text = myXmlTextReader.ReadElementString("Rows")
#End If
#If Aztec Then
                        Case "chkReaderInitialization"
                            chkReaderInitialization.Checked = myXmlTextReader.ReadElementString("chkReaderInitialization")
                        Case "MessageAppend"
                            txtMessageAppend.Text = myXmlTextReader.ReadElementString("MessageAppend")
                        Case "NumberOfSymbols"
                            txtNumberOfSymbols.Text = myXmlTextReader.ReadElementString("NumberOfSymbols")
#End If
#If DataMatrix Then
                        Case "EncodingMode"
                            cboEncodingMode.SelectedItem = myXmlTextReader.ReadElementString("EncodingMode")
                        Case "PreferredFormat"
                            cboPreferredFormat.SelectedItem = myXmlTextReader.ReadElementString("PreferredFormat")
#End If
#If MAXI Then
                        Case "CountryCode"
                            txtCountryCode.Text = myXmlTextReader.ReadElementString("CountryCode")
                        Case "EncodingMode"
                            cboEncodingMode.SelectedItem = myXmlTextReader.ReadElementString("EncodingMode")
                        Case "ServiceClass"
                            txtServiceClass.Text = myXmlTextReader.ReadElementString("ServiceClass")
                        Case "ZipCode"
                            txtZipCode.Text = myXmlTextReader.ReadElementString("ZipCode")
#End If
#If DataBar Or Linear Then
                        Case "BarHeight"
                            txtBarHeight.Text = myXmlTextReader.ReadElementString("BarHeight")
                        Case "Code128Set"
                            cboCode128Set.SelectedIndex = myXmlTextReader.ReadElementString("Code128Set")
                        Case "HRTextColor"
                            Barcode.TextFontColor = Barcode.TextFontColor.FromArgb(myXmlTextReader.ReadElementString("HRTextColor"))
                        Case "ShowHRText"
                            chkShowText.Checked = myXmlTextReader.ReadElementString("ShowHRText")
                        Case "Symbology"
                            cboSymbology.SelectedIndex = myXmlTextReader.ReadElementString("Symbology")
                        Case "TextAbove"
                            chkTextAbove.Checked = myXmlTextReader.ReadElementString("TextAbove")
                        Case "TextMargin"
                            txtTextMargin.Text = myXmlTextReader.ReadElementString("TextMargin")
                        Case "UPCESystem"
                            Barcode.UPCESystem = myXmlTextReader.ReadElementString("UPCESystem")
#End If
#If Linear Then
                        Case "BearerBarHorizontal"
                            txtBearerHorizontal.Text = myXmlTextReader.ReadElementString("BearerBarHorizontal")
                        Case "BearerBarVertical"
                            txtBearerVertical.Text = myXmlTextReader.ReadElementString("BearerBarVertical")
                        Case "CharacterGrouping"
                            txtTextSpacing.Text = myXmlTextReader.ReadElementString("CharacterGrouping")
                        Case "ShowCheckDigit"
                            chkShowCheckDigit.Checked = myXmlTextReader.ReadElementString("ShowCheckDigit")
                            Barcode.CheckCharacterInText = chkShowCheckDigit.Checked
                        Case "UseCheckDigit"
                            chkUseCheckDigit.Checked = myXmlTextReader.ReadElementString("UseCheckDigit")
                        Case "USPSShortBar"
                            txtShortBar.Text = myXmlTextReader.ReadElementString("USPSShortBar")
                        Case "WhiteBarIncrease"
                            txtWhiteBarIncrease.Text = myXmlTextReader.ReadElementString("WhiteBarIncrease")
                        Case "Wide2Narrow"
                            txtW2NRatio.Text = myXmlTextReader.ReadElementString("Wide2Narrow")
#End If
#If DataBar Then
                        Case "CompositeData"
                            txtCompositeData.Text = myXmlTextReader.ReadElementString("CompositeData")
                        Case "DatabarSuggestedHeight"
                            chkDataBarSuggested.Checked = myXmlTextReader.ReadElementString("DatabarSuggestedHeight")
                        Case "IncludeAIInText"
                            chkIncludeAI.Checked = myXmlTextReader.ReadElementString("IncludeAIInText")
                        Case "IncludeLinkageFlagInText"
                            chkIncludeLinkageFlag.Checked = myXmlTextReader.ReadElementString("IncludeLinkageFlagInText")
                        Case "PDFColumns"
                            txtPDFColumns.Text = myXmlTextReader.ReadElementString("PDFColumns")
                        Case "PDFErrorCorrection"
                            cboECLevel.Text = myXmlTextReader.ReadElementString("PDFErrorCorrection")
                        Case "PDFMode"
                            cboCompactionType.Text = myXmlTextReader.ReadElementString("PDFMode")
                        Case "PDFTruncated"
                            chkTruncate.Checked = myXmlTextReader.ReadElementString("PDFTruncated")
                        Case "Segments"
                            cboSegments.SelectedIndex = myXmlTextReader.ReadElementString("Segments")
                        Case "UPCSeparation"
                            txtUPCSeparation.Text = myXmlTextReader.ReadElementString("UPCSeparation")
                        Case "XToYRatio"
                            txtXYRatio.Text = myXmlTextReader.ReadElementString("XToYRatio")
#End If
                    End Select
                End While

                'Close File
                myXmlTextReader.Close()
#If QRCode Then
                '12/28/2010, TB, Added Feature #411, here we check to see the status of the DataToEncode variable, 
                'if the data was in the DataToEncode text box, the VCARD tab, or the Common tab
                If Data(16) = "DTE" Or Data(16) = "" Then 'Data was in the DataToEncode box, if the string is empty then it was an xml file created with an older version.
                    setBarcodeDataFromXML(Data, Enums.TextBoxes.DTE, SuppressChange)
                ElseIf Data(16) = "VCARD" Then 'Data was in the VCARD tab
                    setBarcodeDataFromXML(Data, Enums.TextBoxes.VCARD, SuppressChange)
                ElseIf Data(16) = "Common" Then 'Data was in the Comon tab
                    setBarcodeDataFromXML(Data, Enums.TextBoxes.Common, SuppressChange)
                End If
#End If
            Catch xmlExcept
                MessageBox.Show("Problem loading file:" & FileNameL)
            End Try
        End If
        'Set All text properties.

        'Label for Color Background
        lblBackgroundColor.BackColor = Barcode.BackColor
        lblBackgroundColor.ForeColor = Barcode.BackColor
        Barcode.BackColor = lblBackgroundColor.BackColor
        Barcode.BackColor = Barcode.BackColor

        'Label for Color BarColor
        lblBarColor.ForeColor = Barcode.ForeColor
        lblBarColor.BackColor = Barcode.ForeColor
        Barcode.ForeColor = lblBarColor.ForeColor

        'Label for Color Caption Above 
        lblUpperCaptionColor.ForeColor = Barcode.CaptionTopColor
        lblUpperCaptionColor.BackColor = Barcode.CaptionTopColor
        Barcode.CaptionTopColor = lblUpperCaptionColor.BackColor

        'Label for Color Caption Below 
        lblBottomCaptionColor.ForeColor = Barcode.CaptionBottomColor
        lblBottomCaptionColor.BackColor = Barcode.CaptionBottomColor
        Barcode.CaptionBottomColor = lblBottomCaptionColor.ForeColor

        '7/29/11, TB, Fix bug #428
#If DataBar Or Linear Then
        lblHRTextColor.ForeColor = Barcode.TextFontColor
        lblHRTextColor.BackColor = Barcode.TextFontColor
#End If

        If mnuSetToInches.Checked = False Then
            If mnuSetToMetric.Checked = True Then
#If Not MAXI Then
                Barcode.LeftMarginCM = Val(txtLeftMargin.Text)
                Barcode.TopMarginCM = Val(txtTopMargin.Text)
                ConvertScreenToCM()
#End If
                Barcode.CaptionTopSpace = Val(txtUpperSpace.Text)
                Barcode.CaptionBottomSpace = Val(txtBottomSpace.Text)
            Else
#If Not MAXI Then
                Barcode.LeftMarginCM = ConvertInchestoCM(txtLeftMargin.Text)
                Barcode.TopMarginCM = ConvertInchestoCM(txtTopMargin.Text)
#End If
                Barcode.CaptionTopSpace = ConvertInchestoCM(txtUpperSpace.Text)
                Barcode.CaptionBottomSpace = ConvertInchestoCM(txtBottomSpace.Text)
            End If
        End If

        If mnuSetToMetric.Checked = False Then
            If mnuSetToInches.Checked = True Then
#If Not MAXI Then
                Barcode.LeftMarginCM = Val(txtLeftMargin.Text) * 2.54
                Barcode.TopMarginCM = Val(txtTopMargin.Text) * 2.54
                ConvertScreenToInches()
#End If
                Barcode.CaptionTopSpace = Val(txtUpperSpace.Text) * 2.54
                Barcode.CaptionBottomSpace = Val(txtBottomSpace.Text) * 2.54
            Else
#If Not MAXI Then
                Barcode.LeftMarginCM = ConvertCMtoInches(txtLeftMargin.Text)
                Barcode.TopMarginCM = ConvertCMtoInches(txtTopMargin.Text)
#End If
                Barcode.CaptionTopSpace = ConvertCMtoInches(txtUpperSpace.Text)
                Barcode.CaptionBottomSpace = ConvertCMtoInches(txtBottomSpace.Text)
            End If
        End If
        PicBox.Image = getImage()
    End Sub

    'SaveXMLFile
    Private Sub SaveXMLFile(ByVal NameFile As String, Optional ByRef VCARD As Boolean = False, Optional ByRef DTE As Boolean = False, Optional ByRef Common As Boolean = False)
        Dim FileNameS As String = ""
        Try
            With saveFileDialog1
                ''FileName from command line
                If CMDAPP = 1 Then
                    FileNameS = NameFile
                    Me.Visible = False
                Else
                    ''FileName from dialog box
                    .FileName = FileNameS

                    ''Ensure that it does not load incorrect File extension
                    If (.Filter <> "XML files (*.xml)|*.xml|" & "All files|*.*") Then
                        FileNameS = ""
                    End If

                    .Filter = "XML files (*.xml)|*.xml|" & "All files|*.*"
                    If .ShowDialog() = DialogResult.OK Then
                        FileNameS = .FileName
                    End If
                End If
            End With
        Catch
            Windows.Forms.MessageBox.Show("An error occured while trying to save the file.  Please ensure the filename is properly formatted for the operating system.")
        End Try

        If FileNameS <> "" Then
            Try
                'We will save this XML file and write to it.
                Dim myXmlTextWriter As XmlTextWriter = New XmlTextWriter(FileNameS, System.Text.Encoding.UTF8)
                myXmlTextWriter.Formatting = System.Xml.Formatting.Indented
                myXmlTextWriter.WriteStartDocument(False)

                '''Create the main document element.
                myXmlTextWriter.WriteStartElement("xmlfile")

                '''Write all of the Generator values to the XML file.
                myXmlTextWriter.WriteElementString("ApplyTilde", ApplyTilde.Checked)
                myXmlTextWriter.WriteElementString("BarColor", Barcode.ForeColor.ToArgb)
                myXmlTextWriter.WriteElementString("BackColor", Barcode.BackColor.ToArgb)
                myXmlTextWriter.WriteElementString("CaptionAbove", txtUpperCaption.Text)
                myXmlTextWriter.WriteElementString("CaptionBelow", txtBottomCaption.Text)
                myXmlTextWriter.WriteElementString("CaptionBottomAlignment", cboBottomAlignment.SelectedItem.ToString)
                myXmlTextWriter.WriteElementString("CaptionBottomColor", Barcode.CaptionBottomColor.ToArgb)
                myXmlTextWriter.WriteElementString("CaptionBottomSpace", txtBottomSpace.Text)
                myXmlTextWriter.WriteElementString("CaptionTopAlignment", cboUpperAlignment.SelectedItem.ToString)
                myXmlTextWriter.WriteElementString("CaptionTopColor", Barcode.CaptionTopColor.ToArgb)
                myXmlTextWriter.WriteElementString("CaptionTopSpace", txtUpperSpace.Text)
                myXmlTextWriter.WriteElementString("DataToEncode", txtDataToEncode.Text)
                myXmlTextWriter.WriteElementString("ImageResolution", Barcode.ResolutionCustomDPI)
                myXmlTextWriter.WriteElementString("LastSaveDirectory", LastSaveDirectory)
                myXmlTextWriter.WriteElementString("LastSaveExtension", LastSaveExtension)
                myXmlTextWriter.WriteElementString("Orientation", cboRotation.SelectedItem)
                myXmlTextWriter.WriteElementString("SetUnitInches", mnuSetToInches.Checked)
                myXmlTextWriter.WriteElementString("SetUnitMetric", mnuSetToMetric.Checked)
                myXmlTextWriter.WriteElementString("Width", Barcode.Width)
                myXmlTextWriter.WriteElementString("Top", Barcode.Top)
                myXmlTextWriter.WriteElementString("Left", Barcode.Left)
                myXmlTextWriter.WriteElementString("Height", Barcode.Height)
                If optIndMF.Checked = True Then
                    myXmlTextWriter.WriteElementString("Bitmap", False)
                Else
                    myXmlTextWriter.WriteElementString("Bitmap", True)
                End If
#If Not MAXI Then
                myXmlTextWriter.WriteElementString("X", txtXCM.Text)
                myXmlTextWriter.WriteElementString("LeftMargin", Val(txtLeftMargin.Text))
                myXmlTextWriter.WriteElementString("TopMargin", Val(txtTopMargin.Text))
#End If
#If PDF417 Then
                myXmlTextWriter.WriteElementString("Columns", txtPDFColumns.Text)
                myXmlTextWriter.WriteElementString("EncodingMode", cboEncodingMode.SelectedItem)
                myXmlTextWriter.WriteElementString("ErrorCorrectionLevel", txtPDFEC.Text)
                myXmlTextWriter.WriteElementString("MacroPDFEnable", chkMacroPDFEnable.Checked)
                myXmlTextWriter.WriteElementString("MacroPDFFileID", txtMacroPDFFileID.Text)
                myXmlTextWriter.WriteElementString("MacroPDFLastSegment", chkMacroPDFLastSegment.Checked)
                myXmlTextWriter.WriteElementString("MacroPDFSegmentIndex", txtMacroPDFSegmentIndex.Text)
                myXmlTextWriter.WriteElementString("Truncated", chkTruncate.Checked)
                myXmlTextWriter.WriteElementString("XYRatio", txtXYRatio.Text)
                myXmlTextWriter.WriteElementString("Rows", txtPDFRows.Text)
#End If
#If QRCode Then
                '12/28/2010, TB, Added Feature #411, writing the new properties to the xml file
                myXmlTextWriter.WriteElementString("VCARDWorkNumber", tbWorkNumber.Text)
                myXmlTextWriter.WriteElementString("VCARDEmail", tbEmail.Text)
                myXmlTextWriter.WriteElementString("VCARDWebsite", tbWebsite.Text)
                myXmlTextWriter.WriteElementString("VCARDFirstName", tbFirstName.Text)
                myXmlTextWriter.WriteElementString("VCARDLastName", tbLastName.Text)
                myXmlTextWriter.WriteElementString("VCARDCompany", tbCompany.Text)
                myXmlTextWriter.WriteElementString("VCARDPosition", tbPosition.Text)
                myXmlTextWriter.WriteElementString("VCARDAddress", tbAddress.Text)
                myXmlTextWriter.WriteElementString("VCARDCity", tbCity.Text)
                myXmlTextWriter.WriteElementString("VCARDState", tbState.Text)
                myXmlTextWriter.WriteElementString("VCARDZip", tbZip.Text)

                myXmlTextWriter.WriteElementString("CmWorkNumber", tbWorkNumberCm.Text)
                myXmlTextWriter.WriteElementString("CmEmail", tbEmailCm.Text)
                myXmlTextWriter.WriteElementString("CmText", tbTextCm.Text)
                myXmlTextWriter.WriteElementString("CmWebsite", tbWebsiteCm.Text)

                '12/28/2010, TB, Added Feature #411, here we need to set the status for data to encode, this will be used in the LoadXMLFile method.
                If VCARD = True Then
                    myXmlTextWriter.WriteElementString("DataStatus", "VCARD")
                ElseIf DTE = True Then
                    myXmlTextWriter.WriteElementString("DataStatus", "DTE")
                ElseIf Common = True Then
                    myXmlTextWriter.WriteElementString("DataStatus", "Common")
                End If
#End If
#If Aztec Then
                myXmlTextWriter.WriteElementString("MessageAppend", txtMessageAppend.Text)
                myXmlTextWriter.WriteElementString("NumberOfSymbols", txtNumberOfSymbols.Text)
                myXmlTextWriter.WriteElementString("chkReaderInitialization", chkReaderInitialization.Checked)
#End If
#If DataMatrix Then
                myXmlTextWriter.WriteElementString("EncodingMode", cboEncodingMode.SelectedItem)
                myXmlTextWriter.WriteElementString("PreferredFormat", cboPreferredFormat.SelectedItem)
#End If
#If MAXI Then
                myXmlTextWriter.WriteElementString("ServiceClass", txtServiceClass.Text)
                myXmlTextWriter.WriteElementString("ZipCode", txtZipCode.Text)
                myXmlTextWriter.WriteElementString("CountryCode", txtCountryCode.Text)
                myXmlTextWriter.WriteElementString("EncodingMode", cboEncodingMode.SelectedItem)
#End If
                '7/29/11, TB, Fix bug #427
#If DataBar Or Linear Then
                myXmlTextWriter.WriteElementString("BarHeight", Val(txtBarHeight.Text))
                myXmlTextWriter.WriteElementString("Code128Set", cboCode128Set.SelectedIndex)
                myXmlTextWriter.WriteElementString("HRTextColor", Barcode.TextFontColor.ToArgb)
                myXmlTextWriter.WriteElementString("ShowHRText", chkShowText.Checked)
                myXmlTextWriter.WriteElementString("Symbology", cboSymbology.SelectedIndex)
                myXmlTextWriter.WriteElementString("TextAbove", chkTextAbove.Checked)
                myXmlTextWriter.WriteElementString("TextMargin", Val(txtTextMargin.Text))
                myXmlTextWriter.WriteElementString("UPCESystem", Barcode.UPCESystem)
#End If
#If Linear Then
                myXmlTextWriter.WriteElementString("BearerBarHorizontal", txtBearerHorizontal.Text)
                myXmlTextWriter.WriteElementString("BearerBarVertical", txtBearerVertical.Text)
                myXmlTextWriter.WriteElementString("CharacterGrouping", txtTextSpacing.Text)
                myXmlTextWriter.WriteElementString("ShowCheckDigit", chkShowCheckDigit.Checked)
                myXmlTextWriter.WriteElementString("UseCheckDigit", chkUseCheckDigit.Checked)
                myXmlTextWriter.WriteElementString("USPSShortBar", txtShortBar.Text)
                myXmlTextWriter.WriteElementString("WhiteBarIncrease", txtWhiteBarIncrease.Text)
                myXmlTextWriter.WriteElementString("Wide2Narrow", Val(txtW2NRatio.Text))
#End If
#If DataBar Then
                myXmlTextWriter.WriteElementString("CompositeData", txtCompositeData.Text)
                myXmlTextWriter.WriteElementString("DatabarSuggestedHeight", chkDataBarSuggested.Checked)
                myXmlTextWriter.WriteElementString("IncludeAIInText", chkIncludeAI.Checked)
                myXmlTextWriter.WriteElementString("IncludeLinkageFlagInText", chkIncludeLinkageFlag.Checked)
                myXmlTextWriter.WriteElementString("PDFColumns", txtPDFColumns.Text)
                myXmlTextWriter.WriteElementString("PDFErrorCorrection", cboECLevel.Text)
                myXmlTextWriter.WriteElementString("PDFMode", cboCompactionType.Text)
                myXmlTextWriter.WriteElementString("PDFTruncated", chkTruncate.Checked)
                myXmlTextWriter.WriteElementString("Segments", cboSegments.SelectedIndex)
                myXmlTextWriter.WriteElementString("UPCSeparation", Val(txtUPCSeparation.Text))
                myXmlTextWriter.WriteElementString("XToYRatio", Val(txtXYRatio.Text))
#End If
                ''Close off all elements.
                myXmlTextWriter.WriteEndElement()
                myXmlTextWriter.Flush()
                myXmlTextWriter.Close()
                'End With
            Catch
                Windows.Forms.MessageBox.Show("An error occured while trying to save the file.  Please ensure the filename is properly formatted for the operating system.")
            End Try
        End If
    End Sub

    Private Sub GetRegistryValues()
        Dim regKey As Microsoft.Win32.RegistryKey
        Dim SymbID As String
        Dim cboIndex As Integer
        Dim RegValue As String
        Dim fontSize As Double
        Dim fontName As String

        regKey = Microsoft.Win32.Registry.CurrentUser.OpenSubKey("Software", True)  'true allows this to be writable
        regKey.CreateSubKey(PartialSubKey) 'Creates or opens
        regKey = Microsoft.Win32.Registry.CurrentUser.OpenSubKey(CompleteSubKey, True)
        RegValue = regKey.GetValue("DataToEncode", Barcode.DataToEncode)
        txtDataToEncode.Text = RegValue.ToString()

        RegValue = regKey.GetValue("FirstTime", "True")

        Dim IsWestCoastTimeZone As Boolean = False

        If RegValue.Equals("True") = True Then
            IsWestCoastTimeZone = IsWesternLangSetting()
        End If

        If IsWestCoastTimeZone = False Then
            RegValue = regKey.GetValue("UnitsOfMeasurement", "CM")
        Else
            RegValue = regKey.GetValue("UnitsOfMeasurement", "Inches")
            RegValue = "Inches"
        End If

        If (RegValue = "CM") Then
            mnuSetToMetric.Checked = True
            mnuSetToInches.Checked = False
#If Not MAXI Then
            ConvertScreenToCM()
            RegValue = regKey.GetValue("XDimension", Barcode.XDimensionCM)
            Barcode.XDimensionCM = RegValue
            setRegValXDim(RegValue)

            RegValue = regKey.GetValue("TopMargin", Barcode.TopMarginCM)
            Barcode.TopMarginCM = RegValue
            setRegValTopMargin(RegValue)

            RegValue = regKey.GetValue("LeftMargin", Barcode.LeftMarginCM)
            Barcode.LeftMarginCM = RegValue
            setRegValLeftMargin(RegValue)
#End If
#If Linear Then
            'USPS ShortBar
            RegValue = regKey.GetValue("USPSShortBar", Barcode.PostnetHeightShort)
            Barcode.PostnetHeightShort = RegValue
            setRegValShortBar(RegValue)
#End If
#If DataBar Then
            RegValue = regKey.GetValue("SuppSeparationCM", Barcode.SuppSeparationCM)
            Barcode.SuppSeparationCM = RegValue
            setRegValSuppSeperation(RegValue)
#End If
#If DataBar Or Linear Then
            RegValue = regKey.GetValue("BarHeight", Barcode.BarHeightCM)
            Barcode.BarHeightCM = RegValue
            setRegValBarHeight(RegValue)

            RegValue = regKey.GetValue("TextMargin", Barcode.TextMarginCM)
            Barcode.TextMarginCM = RegValue
            setRegValTextMargin(RegValue)
#End If
        Else
            mnuSetToMetric.Checked = False
            mnuSetToInches.Checked = True
#If Not MAXI Then
            ConvertScreenToInches()
            RegValue = ConvertCMtoInches(regKey.GetValue("XDimension", Barcode.XDimensionCM))
            Dim xdim As Double = (Val(RegValue) * 1000)
            RegValue = xdim.ToString()
            Dim milVal As Double = Val(RegValue)
            milVal = Math.Round(milVal / 1000, 3)
            Barcode.XDimensionCM = ConvertInchestoCM(Microsoft.VisualBasic.Format(milVal, "#.###").ToString())
            setRegValXDim(RegValue)

            RegValue = ConvertCMtoInches(regKey.GetValue("TopMargin", Barcode.TopMarginCM))
            milVal = Val(RegValue)
            Barcode.TopMarginCM = Val(ConvertInchestoCM(Microsoft.VisualBasic.Format(milVal, "#.###").ToString()))
            setRegValTopMargin(RegValue)

            RegValue = ConvertCMtoInches(regKey.GetValue("LeftMargin", Barcode.LeftMarginCM))
            milVal = Val(RegValue)
            Barcode.LeftMarginCM = Val(ConvertInchestoCM(Microsoft.VisualBasic.Format(milVal, "#.###").ToString()))
            setRegValLeftMargin(RegValue)
#End If
#If Linear Then
            'USPS ShortBar
            RegValue = ConvertCMtoInches(regKey.GetValue("USPSShortBar", Barcode.PostnetHeightShort))
            milVal = Val(RegValue)
            Barcode.PostnetHeightShort = ConvertInchestoCM(Microsoft.VisualBasic.Format(milVal, "#.###").ToString())
            setRegValShortBar(RegValue)
#End If
#If DataBar Then
            RegValue = ConvertCMtoInches(regKey.GetValue("SuppSeparationCM", Barcode.SuppSeparationCM))
            milVal = Val(RegValue)
            Barcode.SuppSeparationCM = ConvertInchestoCM(Microsoft.VisualBasic.Format(milVal, "#.###").ToString())
            setRegValSuppSeperation(RegValue)
#End If
#If DataBar Or Linear Then
            RegValue = ConvertCMtoInches(regKey.GetValue("BarHeight", Barcode.BarHeightCM))
            milVal = Val(RegValue)
            Barcode.BarHeightCM = ConvertInchestoCM(Microsoft.VisualBasic.Format(milVal, "#.###").ToString())
            setRegValBarHeight(RegValue)

            RegValue = ConvertCMtoInches(regKey.GetValue("TextMargin", Barcode.TextMarginCM))
            milVal = Val(RegValue)
            Barcode.TextMarginCM = ConvertInchestoCM(Microsoft.VisualBasic.Format(milVal, "#.###").ToString())
            setRegValTextMargin(RegValue)
#End If
        End If
#If PDF417 Then
        RegValue = regKey.GetValue("XYRatio", Barcode.XtoYRatio)
        txtXYRatio.Text = RegValue

        RegValue = regKey.GetValue("PDFRows", Barcode.PDFRows)
        txtPDFRows.Text = RegValue

        RegValue = regKey.GetValue("PDFColumns", Barcode.PDFColumns)
        txtPDFColumns.Text = RegValue

        RegValue = regKey.GetValue("PDF_EC", Barcode.PDFErrorCorrectionLevel)
        txtPDFEC.Text = RegValue

        RegValue = regKey.GetValue("Truncated", Barcode.Truncated.ToString()) 'False or True
        If RegValue.Equals("True") = True Then
            chkTruncate.Checked = True
            Barcode.Truncated = True
        Else
            chkTruncate.Checked = False
            Barcode.Truncated = False
        End If

        RegValue = regKey.GetValue("EncodingMode", Barcode.PDFMode.ToString())
        SymbID = RegValue
        cboIndex = cboEncodingMode.FindString(SymbID)
        cboEncodingMode.SelectedIndex = cboIndex
#End If
#If QRCode Then
        RegValue = regKey.GetValue("Version", Barcode.Version.ToString())
        SymbID = RegValue
        cboIndex = cboVersions.FindString(SymbID)
        cboVersions.SelectedIndex = cboIndex

        RegValue = regKey.GetValue("EncodingMode", Barcode.EncodingMode.ToString())
        SymbID = RegValue
        cboIndex = cboEncodingMode.FindString(SymbID)
        cboEncodingMode.SelectedIndex = cboIndex

        RegValue = regKey.GetValue("ErrorCorrection", Barcode.ErrorCorrection.ToString())
        SymbID = RegValue

        cboIndex = cboErrorCorrectionLevel.FindString(SymbID)
        cboErrorCorrectionLevel.SelectedIndex = cboIndex

        RegValue = regKey.GetValue("VCARDWorkNumber", tbWorkNumber.Text)
        tbWorkNumber.Text = RegValue.ToString()
        RegValue = regKey.GetValue("VCARDEmail", tbEmail.Text)
        tbEmail.Text = RegValue.ToString()
        RegValue = regKey.GetValue("VCARDWebsite", tbWebsite.Text)
        tbWebsite.Text = RegValue.ToString()
        RegValue = regKey.GetValue("VCARDFirstName", tbFirstName.Text)
        tbFirstName.Text = RegValue.ToString()
        RegValue = regKey.GetValue("VCARDLastName", tbLastName.Text)
        tbLastName.Text = RegValue.ToString()
        RegValue = regKey.GetValue("VCARDCompany", tbCompany.Text)
        tbCompany.Text = RegValue.ToString()
        RegValue = regKey.GetValue("VCARDPosition", tbPosition.Text)
        tbPosition.Text = RegValue.ToString()
        RegValue = regKey.GetValue("VCARDAddress", tbAddress.Text)
        tbAddress.Text = RegValue.ToString()
        RegValue = regKey.GetValue("VCARDCity", tbCity.Text)
        tbCity.Text = RegValue.ToString()
        RegValue = regKey.GetValue("VCARDState", tbState.Text)
        tbState.Text = RegValue.ToString()
        RegValue = regKey.GetValue("VCARDZip", tbZip.Text)
        tbZip.Text = RegValue.ToString()

        RegValue = regKey.GetValue("CmWorkNumber", tbWorkNumberCm.Text)
        tbWorkNumberCm.Text = RegValue.ToString()
        RegValue = regKey.GetValue("CmEmail", tbEmailCm.Text)
        tbEmailCm.Text = RegValue.ToString()
        RegValue = regKey.GetValue("CmText", tbTextCm.Text)
        tbTextCm.Text = RegValue.ToString()
        RegValue = regKey.GetValue("CmWebsite", tbWebsiteCm.Text)
        tbWebsiteCm.Text = RegValue.ToString()
#End If
#If Aztec Then
        RegValue = regKey.GetValue("chkReaderInitialization", Barcode.ReaderInitialization.ToString()) 'False or True
        If RegValue.Equals("True") = True Then
            chkReaderInitialization.Checked = True
        Else
            chkReaderInitialization.Checked = False
        End If

        RegValue = regKey.GetValue("NumberOfSymbols", Barcode.NumberOfSymbols)
        txtNumberOfSymbols.Text = RegValue

        RegValue = regKey.GetValue("MessageAppend", Barcode.MessageAppend)
        txtMessageAppend.Text = RegValue.ToString()
#End If
#If DataMatrix Then
        RegValue = regKey.GetValue("PreferredFormat", Barcode.PreferredFormat.ToString())
        SymbID = RegValue
        cboIndex = cboPreferredFormat.FindString(SymbID)
        cboPreferredFormat.SelectedIndex = cboIndex

        RegValue = regKey.GetValue("EncodingMode", Barcode.EncodingMode.ToString())
        SymbID = RegValue
        cboIndex = cboEncodingMode.FindString(SymbID)
        cboEncodingMode.SelectedIndex = cboIndex
#End If
#If MAXI Then
        RegValue = regKey.GetValue("EncodingMode", Barcode.EncodingMode.ToString())
        cboIndex = cboEncodingMode.FindString(RegValue)
        cboEncodingMode.SelectedIndex = cboIndex

        RegValue = regKey.GetValue("CountryCode", Barcode.CountryCode)
        txtCountryCode.Text = RegValue

        RegValue = regKey.GetValue("ServiceClass", Barcode.ServiceClass)
        txtServiceClass.Text = RegValue

        RegValue = regKey.GetValue("ZipCode", Barcode.ZipCode)
        txtZipCode.Text = RegValue
#End If
        '7/29/11, TB, Fix bug #427
#If DataBar Or Linear Then
        RegValue = regKey.GetValue("Symbology", cboSymbology.SelectedItem)
        cboIndex = cboSymbology.FindString(RegValue)
        cboSymbology.SelectedIndex = cboIndex

        RegValue = regKey.GetValue("Code128Set", Barcode.Code128Set.ToString())
        If RegValue.Equals("Auto") = True Then
            cboCode128Set.SelectedIndex = 0
            Barcode.Code128Set = Barcode.Code128Set.Auto
        ElseIf RegValue.Equals("A") = True Then
            cboCode128Set.SelectedIndex = 1
            Barcode.Code128Set = Barcode.Code128Set.A
        ElseIf RegValue.Equals("B") = True Then
            cboCode128Set.SelectedIndex = 2
            Barcode.Code128Set = Barcode.Code128Set.B
        ElseIf RegValue.Equals("C") = True Then
            cboCode128Set.SelectedIndex = 3
            Barcode.Code128Set = Barcode.Code128Set.C
        End If


        RegValue = regKey.GetValue("ShowHRText", Barcode.ShowText.ToString())
        If RegValue.Equals("True") = True Then
            chkShowText.Checked = True
        Else
            chkShowText.Checked = False
        End If

        RegValue = regKey.GetValue("TextAbove", Barcode.ShowTextLocation.ToString())
        If RegValue.Equals("Top") = True Then
            chkTextAbove.Checked = True
        Else
            chkTextAbove.Checked = False
        End If

        'Set the human readable text
        fontName = regKey.GetValue("HRTextFontName", Barcode.Font.Name)
        lblHRTextFont.Text = fontName
        RegValue = regKey.GetValue("HRTextFontSize", Barcode.Font.Size)
        fontSize = Convert.ToDouble(RegValue)
        lblHRTextFont.Text = lblHRTextFont.Text & ", " & RegValue.ToString()
        Barcode.Font = New Font(fontName, fontSize)

        RegValue = regKey.GetValue("HRTextColor", Barcode.TextFontColor.ToArgb())
        lblHRTextColor.ForeColor = Color.FromArgb(Convert.ToInt32(RegValue))
        lblHRTextColor.BackColor = Color.FromArgb(Convert.ToInt32(RegValue))
        Barcode.TextFontColor = Color.FromArgb(Convert.ToInt32(RegValue))
#End If
#If Linear Then
        RegValue = regKey.GetValue("Wide2Narrow", Barcode.NarrowToWideRatio)
        txtW2NRatio.Text = RegValue

        RegValue = regKey.GetValue("UseCheckDigit", Barcode.CheckCharacter.ToString())
        If RegValue.Equals("True") = True Then
            chkUseCheckDigit.Checked = True
        Else
            chkUseCheckDigit.Checked = False
        End If

        RegValue = regKey.GetValue("ShowCheckDigit", Barcode.CheckCharacterInText.ToString())
        If RegValue.Equals("True") = True Then
            chkShowCheckDigit.Checked = True
        Else
            chkShowCheckDigit.Checked = False
        End If

        'Character Grouping
        RegValue = regKey.GetValue("CharacterGrouping", Barcode.CharacterGrouping)
        txtTextSpacing.Text = RegValue.ToString()

        'Bearer Bars
        RegValue = regKey.GetValue("BearerBarVertical", Barcode.BearerBarVertical)
        txtBearerVertical.Text = RegValue.ToString()
        RegValue = regKey.GetValue("BearerBarHorizontal", Barcode.BearerBarHorizontal)
        txtBearerHorizontal.Text = RegValue.ToString()

        'White Space Increase
        RegValue = regKey.GetValue("WhiteBarIncrease", Barcode.WhiteBarIncrease)
        txtWhiteBarIncrease.Text = RegValue.ToString()

        RegValue = regKey.GetValue("UPCSystem", Barcode.UPCESystem.ToString())
        If RegValue.Equals("0") = True Then
            cboUPCESystem.SelectedIndex = 1
            Barcode.UPCESystem = 1
        ElseIf RegValue.ToUpper.Equals("AUTO") = True Then
            cboUPCESystem.SelectedIndex = 0
            Barcode.UPCESystem = "Auto"
        Else
            cboUPCESystem.SelectedIndex = 2
            Barcode.UPCESystem = 2
        End If

#End If
#If DataBar Then
        RegValue = regKey.GetValue("Composite Data", Barcode.CompositeData)
        txtCompositeData.Text = RegValue.ToString()
        Barcode.CompositeData = txtCompositeData.Text

        If txtCompositeData.Text = "" Then
            Barcode.IsComposite = False
        End If

        'brj DataBarSuggestedHeight
        RegValue = regKey.GetValue("DataBarSuggestedHeight", Barcode.DataBarSuggestedHeight.ToString()) 'False or True
        If RegValue.Equals("True") = True Then
            chkDataBarSuggested.Checked = True
            Barcode.DataBarSuggestedHeight = True
        Else
            Barcode.DataBarSuggestedHeight = False
            chkDataBarSuggested.Checked = False
        End If

        'DataBar Expanded Stacked Segments
        RegValue = regKey.GetValue("ExpandedStackedSegments", Barcode.ExpandedStackedSegments.ToString())
        '3/24/2009, TB, changed the segemts to a combo box
        'txtSegments.Text = RegValue
        cboIndex = cboSegments.FindString(RegValue)
        cboSegments.SelectedIndex = cboIndex

        RegValue = regKey.GetValue("ShowLinkageFlag", Barcode.IncludeLinkageFlaginHRText.ToString())
        If RegValue.Equals("True") = True Then
            chkIncludeLinkageFlag.Checked = True
            Barcode.IncludeLinkageFlaginHRText = True
        Else
            chkIncludeLinkageFlag.Checked = False
            Barcode.IncludeLinkageFlaginHRText = False
        End If

        'PDF properties tab
        RegValue = regKey.GetValue("PDFCompactionMode", Barcode.PDFMode.ToString())
        cboIndex = cboCompactionType.FindString(RegValue)
        cboCompactionType.SelectedIndex = cboIndex

        RegValue = regKey.GetValue("PDFColumns", Barcode.PDFColumns)
        txtPDFColumns.Text = RegValue
        Barcode.PDFColumns = txtPDFColumns.Text

        RegValue = regKey.GetValue("TruncatePDF417", Barcode.TruncatePDF417.ToString())
        If RegValue.Equals("True") = True Then
            chkTruncate.Checked = True
            Barcode.TruncatePDF417 = True
        Else
            chkTruncate.Checked = False
            Barcode.TruncatePDF417 = False
        End If

        RegValue = regKey.GetValue("ECLevel", Barcode.PDFErrorCorrectionLevel.ToString())
        cboIndex = cboECLevel.FindString(RegValue)
        cboECLevel.SelectedIndex = cboIndex

        RegValue = regKey.GetValue("XYRatio", Barcode.XtoYRatio)
        txtXYRatio.Text = RegValue
        Barcode.XtoYRatio = Val(txtXYRatio.Text)

        RegValue = regKey.GetValue("UPCSystem", Barcode.UPCESystem.ToString())
        If RegValue.Equals("0") = True Then
            cboUPCESystem.SelectedIndex = 0
            Barcode.UPCESystem = "0"
        Else
            cboUPCESystem.SelectedIndex = 1
            Barcode.UPCESystem = "1"
        End If
#End If
        RegValue = regKey.GetValue("ApplyTilde", Barcode.ApplyTilde.ToString()) 'False or True
        If RegValue.Equals("True") = True Then
            ApplyTilde.Checked = True
        Else
            ApplyTilde.Checked = False
        End If

        RegValue = regKey.GetValue("ImageResolution", Barcode.ResolutionCustomDPI.ToString())
        txtImageDPI.Text = RegValue

        RegValue = regKey.GetValue("Orientation", Barcode.RotationAngle.ToString())
        If RegValue = "Zero_Degrees" Then
            SymbID = "0 Degrees"
        ElseIf RegValue = "Ninety_Degrees" Then
            SymbID = "90 Degrees"
        ElseIf RegValue = "One_Hundred_Eighty_Degrees" Then
            SymbID = "180 Degrees"
        ElseIf RegValue = "Two_Hundred_Seventy_Degrees" Then
            SymbID = "270 Degrees"
        End If

        cboIndex = cboRotation.FindString(SymbID)
        cboRotation.SelectedIndex = cboIndex

        RegValue = regKey.GetValue("ImageToUse", "Independent")
        If RegValue = "Independent" Then
            optIndMF.Checked = True
            optBitmap.Checked = False
        ElseIf RegValue = "Bitmap" Then
            optBitmap.Checked = True
            optIndMF.Checked = False
        End If

        RegValue = regKey.GetValue("CaptionAbove", Barcode.CaptionAbove)
        txtUpperCaption.Text = RegValue

        RegValue = regKey.GetValue("CaptionBelow", Barcode.CaptionBelow)
        txtBottomCaption.Text = RegValue

        If mnuSetToInches.Checked = False Then
            RegValue = regKey.GetValue("CaptionTopSpace", Barcode.CaptionTopSpace)
            Barcode.CaptionTopSpace = RegValue
        Else
            RegValue = ConvertCMtoInches(regKey.GetValue("CaptionTopSpace", Barcode.CaptionTopSpace))
            Dim milVal As Double = Val(RegValue)
            Barcode.CaptionTopSpace = ConvertInchestoCM(Microsoft.VisualBasic.Format(milVal, "#.###").ToString())
        End If

        txtUpperSpace.Text = RegValue

        If mnuSetToInches.Checked = False Then
            RegValue = regKey.GetValue("CaptionBottomSpace", Barcode.CaptionBottomSpace)
            Barcode.CaptionBottomSpace = RegValue
        Else
            RegValue = ConvertCMtoInches(regKey.GetValue("CaptionBottomSpace", Barcode.CaptionBottomSpace))
            Dim milVal As Double = Val(RegValue)
            Barcode.CaptionBottomSpace = ConvertInchestoCM(Microsoft.VisualBasic.Format(milVal, "#.###").ToString())
        End If

        txtBottomSpace.Text = RegValue

        RegValue = regKey.GetValue("CaptionTopAlignment", Barcode.CaptionTopAlignment.ToString())
        cboIndex = cboUpperAlignment.FindString(RegValue)
        cboUpperAlignment.SelectedIndex = cboIndex

        RegValue = regKey.GetValue("CaptionBottomAlignment", Barcode.CaptionBottomAlignment.ToString())
        cboIndex = cboBottomAlignment.FindString(RegValue)
        cboBottomAlignment.SelectedIndex = cboIndex

        RegValue = regKey.GetValue("CaptionBottomColor", Barcode.CaptionBottomColor.ToArgb())
        lblBottomCaptionColor.ForeColor = Color.FromArgb(Convert.ToInt32(RegValue))
        lblBottomCaptionColor.BackColor = Color.FromArgb(Convert.ToInt32(RegValue))
        Barcode.CaptionBottomColor = Color.FromArgb(Convert.ToInt32(RegValue))

        RegValue = regKey.GetValue("CaptionTopColor", Barcode.CaptionTopColor.ToArgb())
        lblUpperCaptionColor.ForeColor = Color.FromArgb(Convert.ToInt32(RegValue))
        lblUpperCaptionColor.BackColor = Color.FromArgb(Convert.ToInt32(RegValue))
        Barcode.CaptionTopColor = Color.FromArgb(Convert.ToInt32(RegValue))

        RegValue = regKey.GetValue("BarColor", Barcode.ForeColor.ToArgb())
        lblBarColor.ForeColor = Color.FromArgb(Convert.ToInt32(RegValue))
        lblBarColor.BackColor = Color.FromArgb(Convert.ToInt32(RegValue))
        Barcode.ForeColor = Color.FromArgb(Convert.ToInt32(RegValue))

        RegValue = regKey.GetValue("BackColor", Barcode.BackColor.ToArgb())
        lblBackgroundColor.ForeColor = Color.FromArgb(Convert.ToInt32(RegValue))
        lblBackgroundColor.BackColor = Color.FromArgb(Convert.ToInt32(RegValue))
        Barcode.BackColor = Color.FromArgb(Convert.ToInt32(RegValue))

        'Set the font of the top caption
        fontName = regKey.GetValue("CaptionFontNameAbove", Barcode.CaptionFontAbove.Name)
        RegValue = regKey.GetValue("CaptionFontSizeAbove", Barcode.CaptionFontAbove.Size)
        fontSize = Convert.ToDouble(RegValue)

        Barcode.CaptionFontAbove = New Font(fontName, fontSize)
        ToolTip1.SetToolTip(cmdCaptionFont, "Sets the font of the top caption. Currently font is " & Barcode.CaptionFontAbove.Name & ", " & Barcode.CaptionFontAbove.Size)

        'set the font of the lower caption
        fontName = regKey.GetValue("CaptionFontNameBelow", Barcode.CaptionFontBelow.Name)
        RegValue = regKey.GetValue("CaptionFontSizeBelow", Barcode.CaptionFontBelow.Size)
        fontSize = Convert.ToDouble(RegValue)
        Barcode.CaptionFontBelow = New Font(fontName, fontSize)
        ToolTip1.SetToolTip(cmdSetBottomCaptionFont, "Sets the font of the bottom caption. Currently font is " & Barcode.CaptionFontBelow.Name & ", " & Barcode.CaptionFontBelow.Size)

        Me.Height = Convert.ToInt32(regKey.GetValue("Height", Me.Height))
        Me.Width = Convert.ToInt32(regKey.GetValue("Width", Me.Width))
        Me.Top = Convert.ToInt32(regKey.GetValue("Top", Me.Top))
        Me.Left = Convert.ToInt32(regKey.GetValue("Left", Me.Left))

        ''get  extension
        RegValue = regKey.GetValue("LastSaveExtension", LastSaveExtension)

        RegValue = regKey.GetValue("SelectedTab", TabControl1.SelectedIndex)
        TabControl1.SelectedIndex = RegValue

        LastSaveExtension = RegValue

        PicBox.Image = getImage()

        regKey.Close()
    End Sub
#If Not MAXI Then
    Private Sub setRegValLeftMargin(ByVal RegValue As String)
        If RegValue.Length > 4 Then
            txtLeftMargin.Text = RegValue.Substring(0, 4)
        Else
            txtLeftMargin.Text = RegValue
        End If
    End Sub

    Private Sub setRegValTopMargin(ByVal RegValue As String)
        If RegValue.Length > 4 Then
            txtTopMargin.Text = RegValue.Substring(0, 4)
        Else
            txtTopMargin.Text = RegValue
        End If
    End Sub

    Private Sub setRegValXDim(ByVal RegValue As String)
        If RegValue.Length > 5 Then
            txtXCM.Text = RegValue.Substring(0, 5)
        Else
            txtXCM.Text = RegValue
        End If
    End Sub

    'Converts labels on screen to represent CM
    Protected Sub ConvertScreenToCM()
#If DataBar Or Linear Then
        lblBarHeight.Text = "Bar Height (CM)"
        lblXDimCM.Text = "X Dimension (CM)"
        lblTopMargin.Text = "Top Margin (CM)"
        lblLeftMargin.Text = "Left Margin (CM)"
        lblTextMargin.Text = "Text Margin (CM)"
        lblLowerCaptionSpace.Text = "Lower Caption Space (CM)"
        lblUpperCaptionSpace.Text = "Upper Caption Space (CM)"
#If Linear Then
        lblShortBar.Text = "USPS ShortBar (CM) [0.100 - 0.144 CM]"
#End If
#Else
        GroupBox1.Text = "Barcode Properties (in CM)"
        lblXDim.Text = "X Dimension"
#End If

    End Sub

    'Converts labels on screen to represent inches
    Protected Sub ConvertScreenToInches()
#If DataBar Or Linear Then
        lblBarHeight.Text = "Bar Height (in.)"
        lblXDimCM.Text = "X Dimension (MILS)"
        lblTopMargin.Text = "Top Margin (in.)"
        lblLeftMargin.Text = "Left Margin (in.)"
        lblTextMargin.Text = "Text Margin (in.)"
        lblLowerCaptionSpace.Text = "Lower Caption Space (in.)"
        lblUpperCaptionSpace.Text = "Upper Caption Space (in.)"
#If Linear Then
        lblShortBar.Text = "USPS ShortBar (in.) [0.039 - 0.057]"
#End If
#Else
        GroupBox1.Text = "Barcode Properties (in inches)"
        lblXDim.Text = "X Dim (MILS)"
#End If
    End Sub
#End If
#If Linear Then
    Private Sub setRegValShortBar(ByVal RegValue As String)
        If RegValue.Length > 4 Then
            txtShortBar.Text = RegValue.Substring(0, 4)
        Else
            txtShortBar.Text = RegValue
        End If
    End Sub
#End If
#If DataBar Then
    Private Sub setRegValSuppSeperation(ByVal RegValue As String)
        If RegValue.Length > 4 Then
            txtUPCSeparation.Text = RegValue.Substring(0, 4)
        Else
            txtUPCSeparation.Text = RegValue
        End If
    End Sub
#End If
#If DataBar Or Linear Then
    Private Sub setRegValBarHeight(ByVal RegValue As String)
        If RegValue.Length > 4 Then
            txtBarHeight.Text = RegValue.Substring(0, 4)
        Else
            txtBarHeight.Text = RegValue
        End If
    End Sub

    Private Sub setRegValTextMargin(ByVal RegValue As String)
        Dim teststr As String
        If RegValue.Length > 4 Then
            txtTextMargin.Text = RegValue.Substring(0, 4)
        Else
            txtTextMargin.Text = RegValue
        End If
    End Sub
#End If

    Public Sub SetRegistryValues()
        '*** V2006 Addition - added next line to keep other values if error
        On Error Resume Next
        Dim regKey As Microsoft.Win32.RegistryKey
        regKey = Microsoft.Win32.Registry.CurrentUser.OpenSubKey("Software", True)  'true allows this to be writable
        regKey.CreateSubKey(PartialSubKey) 'Creates or opens
        regKey = Microsoft.Win32.Registry.CurrentUser.OpenSubKey(CompleteSubKey, True)
        'regKey.SetValue(stringkey, datatostore)
        'Get the value from reg.  If reg key doesn't exist set the value with the default from the control
        regKey.SetValue("DataToEncode", Barcode.DataToEncode)
        regKey.SetValue("ApplyTilde", Barcode.ApplyTilde.ToString())
        regKey.SetValue("ImageResolution", txtImageDPI.Text)
        regKey.SetValue("Orientation", Barcode.RotationAngle.ToString())

#If Not MAXI Then
        regKey.SetValue("XDimension", Barcode.XDimensionCM)
        regKey.SetValue("XDimensionMils", Barcode.XDimensionMILS)
        regKey.SetValue("TopMargin", Barcode.TopMarginCM)
        regKey.SetValue("LeftMargin", Barcode.LeftMarginCM)
#End If
#If PDF417 Then
        regKey.SetValue("EncodingMode", cboEncodingMode.Text.ToString())
        regKey.SetValue("Truncated", Barcode.Truncated.ToString())
        regKey.SetValue("XYRatio", Barcode.XtoYRatio.ToString())
        regKey.SetValue("PDFRows", Barcode.PDFRows.ToString())
        regKey.SetValue("PDFColumns", Barcode.PDFColumns.ToString())
        regKey.SetValue("PDF_EC", Barcode.PDFErrorCorrectionLevel.ToString())
#End If
#If QRCode Then
        regKey.SetValue("VCARDWorkNumber", tbWorkNumber.Text)
        regKey.SetValue("VCARDEmail", tbEmail.Text)
        regKey.SetValue("VCARDWebsite", tbWebsite.Text)
        regKey.SetValue("VCARDFirstName", tbFirstName.Text)
        regKey.SetValue("VCARDLastName", tbLastName.Text)
        regKey.SetValue("VCARDCompany", tbCompany.Text)
        regKey.SetValue("VCARDPosition", tbPosition.Text)
        regKey.SetValue("VCARDAddress", tbAddress.Text)
        regKey.SetValue("VCARDCity", tbCity.Text)
        regKey.SetValue("VCARDState", tbState.Text)
        regKey.SetValue("VCARDZip", tbZip.Text)

        regKey.SetValue("CmWorkNumber", tbWorkNumberCm.Text)
        regKey.SetValue("CmEmail", tbEmailCm.Text)
        regKey.SetValue("CmText", tbTextCm.Text)
        regKey.SetValue("CmWebsite", tbWebsiteCm.Text)

        regKey.SetValue("EncodingMode", cboEncodingMode.Text.ToString())
        regKey.SetValue("Version", cboVersions.Text.ToString())
        regKey.SetValue("ErrorCorrection", cboErrorCorrectionLevel.Text.ToString())
#End If
#If Aztec Then
        regKey.SetValue("MessageAppend", Barcode.MessageAppend)
        regKey.SetValue("NumberOfSymbols", Barcode.NumberOfSymbols)
        regKey.SetValue("chkReaderInitialization", Barcode.ReaderInitialization.ToString())
#End If
#If DataMatrix Then
        regKey.SetValue("EncodingMode", cboEncodingMode.Text.ToString())
        regKey.SetValue("PreferredFormat", cboPreferredFormat.Text.ToString())
#End If
#If MAXI Then
        regKey.SetValue("CountryCode", Barcode.CountryCode)
        regKey.SetValue("ServiceClass", Barcode.ServiceClass)
        regKey.SetValue("ZipCode", Barcode.ZipCode)
        regKey.SetValue("EncodingMode", Barcode.EncodingMode.ToString())
#End If
#If Linear Then
        regKey.SetValue("USPSShortBar", Barcode.PostnetHeightShort)
        regKey.SetValue("Wide2Narrow", Barcode.NarrowToWideRatio)
        regKey.SetValue("UseCheckDigit", Barcode.CheckCharacter.ToString())
        regKey.SetValue("ShowCheckDigit", Barcode.CheckCharacterInText.ToString())
        regKey.SetValue("CharacterGrouping", Barcode.CharacterGrouping.ToString())
        regKey.SetValue("BearerBarVertical", Barcode.BearerBarVertical.ToString())
        regKey.SetValue("BearerBarHorizontal", Barcode.BearerBarHorizontal.ToString())
        regKey.SetValue("WhiteBarIncrease", Barcode.WhiteBarIncrease.ToString())
#End If
#If DataBar Then
        regKey.SetValue("Composite Data", Barcode.CompositeData)
        regKey.SetValue("SuppSeparationCM", Barcode.SuppSeparationCM)

        '3/24/2009, TB, changed the segemts to a combo box
        regKey.SetValue("ExpandedStackedSegments", Barcode.ExpandedStackedSegments.ToString())
        regKey.SetValue("DataBarSuggestedHeight", Barcode.DataBarSuggestedHeight.ToString()) 'brj

        'PDF properties tab
        regKey.SetValue("PDFCompactionMode", Barcode.PDFMode.ToString())
        regKey.SetValue("PDFColumns", Barcode.PDFColumns)
        regKey.SetValue("TruncatePDF417", Barcode.TruncatePDF417.ToString())
        regKey.SetValue("XYRatio", Barcode.XtoYRatio.ToString())
        regKey.SetValue("ECLevel", cboECLevel.Text)

        'text & color Tab
        regKey.SetValue("ShowLinkageFlag", Barcode.IncludeLinkageFlaginHRText.ToString())
        regKey.SetValue("ShowAIinText", Barcode.IncludeAIinHRText.ToString())
#End If
#If DataBar Or Linear Then
        regKey.SetValue("BarHeight", Barcode.BarHeightCM)
        regKey.SetValue("TextMargin", Barcode.TextMarginCM)
        regKey.SetValue("Symbology", cboSymbology.SelectedItem)
        regKey.SetValue("Code128Set", Barcode.Code128Set.ToString())
        regKey.SetValue("UPCSystem", Barcode.UPCESystem.ToString())
        regKey.SetValue("ShowHRText", Barcode.ShowText.ToString())
        regKey.SetValue("TextAbove", Barcode.ShowTextLocation.ToString())
        regKey.SetValue("HRTextColor", Barcode.TextFontColor.ToArgb())
        regKey.SetValue("HRTextFontName", Barcode.Font.Name)
        regKey.SetValue("HRTextFontSize", Barcode.Font.Size)
#End If
        If mnuSetToInches.Checked = True Then
            regKey.SetValue("UnitsOfMeasurement", "Inches")
        Else
            regKey.SetValue("UnitsOfMeasurement", "CM")
        End If
        If optIndMF.Checked = True Then
            regKey.SetValue("ImageToUse", "Independent")
        ElseIf optBitmap.Checked = True Then
            regKey.SetValue("ImageToUse", "Bitmap")
        End If
        regKey.SetValue("CaptionAbove", Barcode.CaptionAbove.ToString())
        regKey.SetValue("CaptionBelow", Barcode.CaptionBelow.ToString())
        regKey.SetValue("CaptionTopSpace", Barcode.CaptionTopSpace)
        regKey.SetValue("CaptionBottomSpace", Barcode.CaptionBottomSpace)

        If Barcode.CaptionTopAlignment.ToString() = "Near" Then
            regKey.SetValue("CaptionTopAlignment", "Left")
        ElseIf Barcode.CaptionTopAlignment.ToString() = "Center" Then
            regKey.SetValue("CaptionTopAlignment", "Center")
        ElseIf Barcode.CaptionTopAlignment.ToString() = "Far" Then
            regKey.SetValue("CaptionTopAlignment", "Right")
        End If
        If Barcode.CaptionBottomAlignment.ToString() = "Near" Then
            regKey.SetValue("CaptionBottomAlignment", "Left")
        ElseIf Barcode.CaptionBottomAlignment.ToString() = "Center" Then
            regKey.SetValue("CaptionBottomAlignment", "Center")
        ElseIf Barcode.CaptionBottomAlignment.ToString() = "Far" Then
            regKey.SetValue("CaptionBottomAlignment", "Right")
        End If

        regKey.SetValue("CaptionBottomColor", Barcode.CaptionBottomColor.ToArgb())
        regKey.SetValue("CaptionTopColor", Barcode.CaptionTopColor.ToArgb())

        regKey.SetValue("BarColor", Barcode.ForeColor.ToArgb())
        regKey.SetValue("BackColor", Barcode.BackColor.ToArgb())

        regKey.SetValue("CaptionFontNameBelow", Barcode.CaptionFontBelow.Name)
        regKey.SetValue("CaptionFontSizeBelow", Barcode.CaptionFontBelow.Size)

        regKey.SetValue("CaptionFontNameAbove", Barcode.CaptionFontAbove.Name)
        regKey.SetValue("CaptionFontSizeAbove", Barcode.CaptionFontAbove.Size)

        regKey.SetValue("Height", Me.Height.ToString())
        regKey.SetValue("Width", Me.Width.ToString())
        regKey.SetValue("Top", Me.Top.ToString())
        regKey.SetValue("Left", Me.Left.ToString())
        regKey.SetValue("FirstTime", "False")

        ''set extension
        regKey.SetValue("LastSaveExtension", LastSaveExtension)

        regKey.SetValue("SelectedTab", TabControl1.SelectedIndex)

        regKey.Close()
    End Sub

    Public Function IsWesternLangSetting() As Boolean
        Dim thisThread As System.Threading.Thread = System.Threading.Thread.CurrentThread
        Dim originalCulture As System.Globalization.CultureInfo = thisThread.CurrentCulture

        Dim rtrnValue As Boolean = False
        If originalCulture.EnglishName.Equals("English (United States)") = True Then
            rtrnValue = True
        End If
        Return rtrnValue
    End Function

    '1/6/2010 BRJ Fixes issue Jack found 120 dpi
    Sub fixFonts(ByVal cA As Control)
        For Each c As Control In cA.Controls
            If TypeOf c Is Panel Or TypeOf c Is GroupBox Or TypeOf c Is TabControl Or TypeOf c Is TabPage Then
                fixFonts(c)
            End If
            c.Font = New Font(c.Font.FontFamily, c.Font.Size * 96 / 72, c.Font.Style, GraphicsUnit.Pixel)
        Next
    End Sub

    Public Sub txtBoxSelectAll(ByRef txtBox As TextBox)
        txtBox.SelectAll()
    End Sub

    Private Sub SetToolTips(ByRef ToolTip1 As ToolTip)
        ToolTip1.SetToolTip(txtDataToEncode, "The data that will be encoded in the barcode.")
        ToolTip1.SetToolTip(txtImageDPI, "The resolution, in dots per inch, of the image that will be created.")
        ToolTip1.SetToolTip(cboRotation, "The rotation of the image, in degrees.")
        ToolTip1.SetToolTip(txtUpperCaption, "Caption that will appear above the barcode.")
        ToolTip1.SetToolTip(txtBottomCaption, "Caption that will appear below the barcode.")
        ToolTip1.SetToolTip(txtUpperSpace, "Sets the distance between the top of the image and the top of the upper caption.")
        ToolTip1.SetToolTip(txtBottomSpace, "Sets the distance between the caption on the bottom and the bottom of the text below the barcode.")
        ToolTip1.SetToolTip(optIndMF, "If selected the image that is copied to the clipboard will be a metafile, independent of the resolution specified in the Image DPI text box.")
        ToolTip1.SetToolTip(optBitmap, "If selected the image that is copied to the clipboard will be a bitmap, dependent on the resolution specified in the Image DPI text box.")
#If Not MAXI Then
        ToolTip1.SetToolTip(txtXCM, "Specify the width of the narrowest bars/squares in the barcode.")
        ToolTip1.SetToolTip(txtTopMargin, "Specify the distance between the top of the image and the top of the barcode.")
        ToolTip1.SetToolTip(txtLeftMargin, "Specify the distance between the left side of the image and the first bar in the barcode.")
#End If
#If Aztec Then
        ToolTip1.SetToolTip(txtNumberOfSymbols, "Sets number of symbols to be created, The data to encoded will be parsed accross all symbols")
        ToolTip1.SetToolTip(chkReaderInitialization, "Adds the reader initialization symbol to the barcode for older scanners, which require it.")
        ToolTip1.SetToolTip(txtMessageAppend, "Specifies the message appended across multiple symbols. Only valid if NumberOfSymbols is greater than 1.")
#End If
#If DataMatrix Then
        ToolTip1.SetToolTip(cboPreferredFormat, "Set the size of the resulting symbol")
#End If
#If DataBar Then
        ToolTip1.SetToolTip(txtUPCSeparation, "Specify the space between the main barcode and the supplement for UPC/EAN")
        ToolTip1.SetToolTip(txtCompositeData, "Specify the data for the composite portion of the barcode")
        ToolTip1.SetToolTip(cboSegments, "Sets the number of segments for the Data Bar Expanded Symbology.")
#End If
#If Linear Then
        ToolTip1.SetToolTip(txtTextSpacing, "Determines the number of characters between spaces in the text underneath the barcode. Valid values are 0, 3, 4 and 5.")
        ToolTip1.SetToolTip(txtWhiteBarIncrease, "A decimal percentage value that increases the white space between bars to improve readability.")
        ToolTip1.SetToolTip(txtW2NRatio, "The wide to narrow ratio of symbologies that only contain narrow and wide bars such as Code 39. Common values are 2, 2.5, 2.75 and 3.")
        ToolTip1.SetToolTip(chkUseCheckDigit, "Automatically adds the check digit to the barcode. The check digit is required for all symbologies except Code 39, Industrial 2 of 5 and Codabar.")
        ToolTip1.SetToolTip(txtShortBar, "Specifies the height of the short bars in the Postnet and Planet barcodes.")
        ToolTip1.SetToolTip(txtBearerVertical, "The width of the vertical bearer bars as a multiple of the XDimension; valid options are 0-10.")
        ToolTip1.SetToolTip(txtBearerHorizontal, "The width of the horizontal bearer bars as a multiple of the XDimension; valid options are 0-10.")
#End If
#If MAXI Then
        ToolTip1.SetToolTip(txtCountryCode, "A 3-digit number representing the country code.")
        ToolTip1.SetToolTip(txtServiceClass, "A 3 digit number representing the service code.")
        ToolTip1.SetToolTip(txtZipCode, "The postal code; mode 2 uses a 9-digit numeric postal code and mode 3 uses a 6 character alphanumeric postal code.")
#End If
#If PDF417 Then
        ToolTip1.SetToolTip(txtPDFRows, "Sets the number of rows. It is recommended to leave this setting at 0, the default.")
        ToolTip1.SetToolTip(chkMacroPDFEnable, "When checked, indicates that this barcode is part of a Macro sequence.")
        ToolTip1.SetToolTip(txtMacroPDFFileID, "Assigns a file id to the Macro barcode. Each barcode in the sequence must have the same file id assigned to it. Valid options are 0-899.")
        ToolTip1.SetToolTip(txtMacroPDFSegmentIndex, "The index number of each Macro symbol must have a unique segment index, starting at zero and incrementing thereafter by one.")
        ToolTip1.SetToolTip(chkMacroPDFLastSegment, "When checked, indicates that this is the final barcode in the Macro sequence.")
#End If
#If DataBar Or Linear Then
        ToolTip1.SetToolTip(ApplyTilde, "Specify whether a tilde in a Code 128 barcode prefaces ASCII character values.")
        ToolTip1.SetToolTip(txtTextMargin, "Specify the distance between the bottom of the barcode and the text under the barcode.")
        ToolTip1.SetToolTip(txtBarHeight, "Specify the height of the bars in the barcode.")
        ToolTip1.SetToolTip(cboSymbology, "Select the type of barcode.")
        ToolTip1.SetToolTip(chkShowText, "Determines if the text in the bacode should be visible.")
        ToolTip1.SetToolTip(chkTextAbove, "Determines if the text in the bacode should appear above the barcode.")
        ToolTip1.SetToolTip(cboCode128Set, "Character set to use for Code 128 barcodes.")
        ToolTip1.SetToolTip(cboUPCESystem, "UPCE system to use for creating UPC/EAN barcodes.")
#Else
        ToolTip1.SetToolTip(ApplyTilde, "Specify whether a tilde in the barcode data prefaces ASCII character values.")
#End If
#If DataBar Or PDF417 Then
        ToolTip1.SetToolTip(txtXYRatio, "Ratio between narrow bars and wide bars.")
        ToolTip1.SetToolTip(txtPDFColumns, "The number of data columns in the PDF417 barcode. The default is 0 and the maximum is 30.")
        ToolTip1.SetToolTip(chkTruncate, "When checked, the right hand side of the PDF417 is removed or truncated.")
        'ToolTip1.SetToolTip(txtPDFEC, "More error correction creates a larger symbol that can withstand more damage.")
#End If
#If DataMatrix Or PDF417 Or QRCode Or MAXI Then
        ToolTip1.SetToolTip(cboEncodingMode, "Specifies the method of encoding the data into the barcode")
#End If
    End Sub
#End Region

#Region "QRCode Specific Methods"
#If QRCode Then
    '12/28/2010, TB, Added Feature #411
    Private Sub setBarcodeDataFromXML(ByVal Data() As String, ByVal dataStatus As Enums.TextBoxes, ByRef SuppressChange As Boolean)
        Select Case dataStatus
            Case Enums.TextBoxes.DTE
                setDTETxtBoxFromXML(Data)
                SuppressChange = True
                setVCARDTxtBoxesFromXML(Data)
                setCommonTxtBoxesFromXML(Data)
                SuppressChange = False
            Case Enums.TextBoxes.VCARD
                setVCARDTxtBoxesFromXML(Data)
                SuppressChange = True
                setDTETxtBoxFromXML(Data)
                setCommonTxtBoxesFromXML(Data)
                SuppressChange = False
            Case Enums.TextBoxes.Common.Common
                setCommonTxtBoxesFromXML(Data)
                SuppressChange = True
                setDTETxtBoxFromXML(Data)
                setVCARDTxtBoxesFromXML(Data)
                SuppressChange = False
        End Select
    End Sub

    '12/28/2010, TB, Added Feature #411
    Sub setDTETxtBoxFromXML(ByVal Data() As String)
        txtDataToEncode.Text = Data(0)
    End Sub

    '12/28/2010, TB, Added Feature #411
    Sub setVCARDTxtBoxesFromXML(ByVal Data() As String)
        tbWorkNumber.Text = Data(1)
        tbEmail.Text = Data(2)
        tbWebsite.Text = Data(3)
        tbFirstName.Text = Data(4)
        tbLastName.Text = Data(5)
        tbCompany.Text = Data(6)
        tbPosition.Text = Data(7)
        tbAddress.Text = Data(8)
        tbCity.Text = Data(9)
        tbState.Text = Data(10)
        tbZip.Text = Data(11)
    End Sub

    '12/28/2010, TB, Added Feature #411
    Sub setCommonTxtBoxesFromXML(ByVal Data() As String)
        tbWorkNumberCm.Text = Data(12)
        tbEmailCm.Text = Data(13)
        tbTextCm.Text = Data(14)
        tbWebsiteCm.Text = Data(15)
    End Sub
#End If
#End Region
End Class
Public Class HelpFile
    Public Shared Sub Open()
        Dim url As String = Application.StartupPath & "\Barcode_Image_Generator.chm"
        Try
            System.Diagnostics.Process.Start(url)
        Catch
            Try
                Shell(url)
            Catch
                MsgBox("To access the help file, please choose the icon in the appropriate program group under Start - Programs - IDAutomation...", , "Help File Access")
            End Try
        End Try
    End Sub
End Class